;$$p5200	- MCF5200 CPU
;$$o5200	- MCF5200 opt
;$$m4		- ELFEMB mnem.
;$$ko 0		- Reorder info
;$$sz 0		- Size opt info
	NAME	"tftp.c"
; -X options:
;$$x X1=4 X7=1 X8=1 X12=1 X15=2 X16=20 X17=1 X18=4
;$$x X19=1 X35=1 X39=5200 X44=1 X71=1 X74=5 X76=1 X80=1
;$$x X84=-2 X86=6 X91=1 X93=4 X111=1 X114=7 X116=1 X119=44
;$$x X201=136
	PSECT
;$$bf
	ALIGN	4
	XDEF	_tftp_rrq
_tftp_rrq:
	link	a6,#-256
	lea	-12(a7),a7
;$$br
	movem.l	d6/d7/a5,(a7)
;$$er
	move.l	8(a6),a5
	tst.l	a5
	jne	.L2
	moveq	#0,d0
	jra	.L1
.L2:
	tst.l	12(a6)
	jne	.L3
	moveq	#0,d0
	jra	.L1
.L3:
	moveq	#1,d0
	move.w	d0,-256(a6)
	move.l	a5,-(a7)
	pea	-254(a6)
;$$fn 0x303
	jbsr	_strcpy
	addq.l	#8,a7
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_strlen
	addq.l	#4,a7
	addq.l	#3,d0
	move.l	d0,d7
	lea	.L4,a0
	move.l	a0,-(a7)
	move.l	a6,a0
	add.l	d7,a0
	pea	-256(a0)
;$$fn 0x303
	jbsr	_strcpy
	addq.l	#8,a7
	lea	.L4,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_strlen
	addq.l	#4,a7
	add.l	d7,d0
	addq.l	#1,d0
	move.l	d0,d7
	move.l	d7,-(a7)
	pea	-256(a6)
	pea	69.w
	moveq	#0,d0
	move.w	18(a6),d0
	move.l	d0,-(a7)
	move.l	12(a6),-(a7)
	move.l	_tftp_nif,-(a7)
;$$fn 0x303
	jbsr	_udp_send
	lea	24(a7),a7
	move.l	d0,d6
	move.l	d6,d0
.L1:
;$$be
;$$br
	movem.l	-268(a6),d6/d7/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_tftp_rrq,@function
	SIZE	_tftp_rrq,.-_tftp_rrq

; Allocations for _tftp_rrq
;	a5	fn
;	12(a6)	host
;	18(a6)	localport
;	-256(a6)	data
;	d7	i
;	d6	retval
;$$bf
	ALIGN	4
	XDEF	_tftp_ack
_tftp_ack:
	link	a6,#-8
	moveq	#4,d0
	move.w	d0,-4(a6)
	move.w	22(a6),-2(a6)
	pea	4.w
	pea	-4(a6)
	moveq	#0,d0
	move.w	14(a6),d0
	move.l	d0,-(a7)
	moveq	#0,d0
	move.w	18(a6),d0
	move.l	d0,-(a7)
	move.l	8(a6),-(a7)
	move.l	_tftp_nif,-(a7)
;$$fn 0x303
	jbsr	_udp_send
	lea	24(a7),a7
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_tftp_ack,@function
	SIZE	_tftp_ack,.-_tftp_ack

; Allocations for _tftp_ack
;	8(a6)	host
;	14(a6)	remoteport
;	18(a6)	localport
;	22(a6)	block
;	-4(a6)	ackdata
;$$bf
	ALIGN	4
	XDEF	_tftp_handler
_tftp_handler:
	link	a6,#-0
;$$br
	move.l	a5,-(a7)
	move.l	d7,-(a7)
;$$er
	move.l	20(a6),a5
	moveq	#1,d7
	moveq	#0,d0
	move.w	(a5),d0
	subq.l	#3,d0
	jeq	.L8
	subq.l	#2,d0
	jeq	.L9
	jra	.L10
.L8:
	move.l	12(a6),d0
	move.l	d0,_tftp_ipframe
	move.l	16(a6),d0
	move.l	d0,_tftp_udpframe
	move.l	a5,d0
	addq.l	#4,d0
	move.l	d0,_tftp_next_char
	moveq	#-12,d0
	add.l	24(a6),d0
	move.l	d0,_tftp_buf_length
	clr.l	_tftp_buf_count
	jra	.L7
.L9:
	moveq	#0,d0
	move.w	2(a5),d0
	move.l	d0,-(a7)
	lea	.L11,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#8,a7
	pea	4(a5)
	lea	.L12,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#8,a7
.L10:
	moveq	#0,d7
.L7:
	move.l	d7,d0
;$$be
;$$br
	movem.l	-8(a6),d7/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_tftp_handler,@function
	SIZE	_tftp_handler,.-_tftp_handler

; Allocations for _tftp_handler
;	not allocated	nif
;	12(a6)	ipframe
;	16(a6)	udpframe
;	a5	udpdata
;	24(a6)	length
;	d7	keep
;$$bf
	ALIGN	4
	XDEF	_tftp_in_char
_tftp_in_char:
	link	a6,#-8
	lea	-20(a7),a7
;$$br
	movem.l	d5/d6/d7/a4/a5,(a7)
;$$er
	move.l	_tftp_buf_length,d0
	cmp.l	_tftp_buf_count,d0
	jgt	.L20
	move.l	_tftp_udpframe,a5
	addq.l	#8,a5
	move.l	_tftp_udpframe,a0
	move.w	(a0),d7
	move.w	2(a5),d6
	move.l	_tftp_ipframe,-(a7)
;$$fn 0x303
	jbsr	_nbuf_release
	addq.l	#4,a7
	move.l	_tftp_buf_length,d0
	cmp.l	#512,d0
	jge	.L15
	move.l	_tftp_buf_length,d0
	cmp.l	_tftp_buf_count,d0
	jge	.L14
	moveq	#-1,d0
	jra	.L13
.L14:
	move.l	d6,-(a7)
	move.w	_tftp_localport,d0
	move.l	d0,-(a7)
	move.l	d7,-(a7)
	move.l	#_tftp_server,-(a7)
;$$fn 0x303
	jbsr	_tftp_ack
	lea	16(a7),a7
	addq.l	#1,_tftp_buf_count
	moveq	#-1,d0
	jra	.L13
.L15:
	moveq	#0,d5
.L17:
	tst.l	d5
	jne	.L20
	move.l	d6,-(a7)
	move.w	_tftp_localport,d0
	move.l	d0,-(a7)
	move.l	d7,-(a7)
	move.l	#_tftp_server,-(a7)
;$$fn 0x303
	jbsr	_tftp_ack
	lea	16(a7),a7
	move.l	#524288,-(a7)
	pea	-4(a6)
	moveq	#0,d0
	move.w	_tftp_localport,d0
	move.l	d0,-(a7)
	clr.l	-(a7)
	move.l	_tftp_nif,-(a7)
;$$fn 0x303
	jbsr	_udp_wait
	lea	20(a7),a7
	move.l	d0,a4
	tst.l	a4
	jeq	.L18
	moveq	#1,d5
	jra	.L17
.L18:
	lea	.L23,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#4,a7
	moveq	#-1,d0
	jra	.L13
.L20:
	tst.l	_tftp_next_char
	jeq	.L21
	addq.l	#1,_tftp_bytes_read
	addq.l	#1,_tftp_buf_count
	move.l	_tftp_next_char,a0
	addq.l	#1,_tftp_next_char
	moveq	#0,d0
	move.b	(a0),d0
	jra	.L13
.L21:
	moveq	#-1,d0
.L13:
;$$be
;$$br
	movem.l	-28(a6),d5/d6/d7/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_tftp_in_char,@function
	SIZE	_tftp_in_char,.-_tftp_in_char

; Allocations for _tftp_in_char
;	a5	data
;	d7	remoteport
;	d6	block
;	d5	done
;	a4	ipframe
;	-4(a6)	udpframe
;$$bf
	ALIGN	4
	XDEF	_tftp_start
_tftp_start:
	link	a6,#-8
	lea	-16(a7),a7
;$$br
	movem.l	d7/a3/a4/a5,(a7)
;$$er
	move.l	8(a6),a5
	move.l	12(a6),a4
	clr.l	_tftp_bytes_read
	clr.l	_tftp_next_char
	clr.l	_tftp_buf_count
	clr.l	_tftp_buf_length
	clr.l	_tftp_udpframe
	clr.l	_tftp_ipframe
	move.b	(a4),_tftp_server
	move.b	1(a4),d0
	move.b	d0,_tftp_server+1
	move.b	2(a4),d0
	move.b	d0,_tftp_server+2
	move.b	3(a4),d0
	move.b	d0,_tftp_server+3
	move.l	#_nif1,d0
	move.l	d0,_tftp_nif
	move.l	_tftp_nif,a0
	move.l	76(a0),a0
	move.l	_tftp_nif,-(a7)
	jbsr	(a0)
	addq.l	#4,a7
	move.l	_tftp_nif,a0
	move.l	80(a0),a0
	move.l	_tftp_nif,-(a7)
	jbsr	(a0)
	addq.l	#4,a7
;$$fn 0x303
	jbsr	_board_enable_interrupts
;$$fn 0x303
	jbsr	_udp_obtain_free_port
	move.w	d0,_tftp_localport
	move.l	#_tftp_handler,-(a7)
	moveq	#0,d0
	move.w	_tftp_localport,d0
	move.l	d0,-(a7)
;$$fn 0x303
	jbsr	_udp_bind_port
	addq.l	#8,a7
	moveq	#0,d7
.L26:
	tst.l	d7
	jne	.L25
	move.w	_tftp_localport,d0
	move.l	d0,-(a7)
	move.l	#_tftp_server,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_tftp_rrq
	lea	12(a7),a7
	tst.l	d0
	jne	.L27
	moveq	#-1,d0
	jra	.L24
.L27:
	move.l	#524288,-(a7)
	pea	-4(a6)
	moveq	#0,d0
	move.w	_tftp_localport,d0
	move.l	d0,-(a7)
	clr.l	-(a7)
	move.l	_tftp_nif,-(a7)
;$$fn 0x303
	jbsr	_udp_wait
	lea	20(a7),a7
	move.l	d0,a3
	tst.l	a3
	jeq	.L28
	moveq	#1,d7
	jra	.L26
.L28:
	lea	.L23,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#4,a7
	moveq	#0,d0
	jra	.L24
.L25:
	moveq	#1,d0
.L24:
;$$be
;$$br
	movem.l	-24(a6),d7/a3/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_tftp_start,@function
	SIZE	_tftp_start,.-_tftp_start

; Allocations for _tftp_start
;	a5	fn
;	a4	Server
;	a3	ipframe
;	-4(a6)	udpframe
;	d7	done
;$$bf
	ALIGN	4
	XDEF	_tftp_end
_tftp_end:
	link	a6,#-0
	tst.l	8(a6)
	jeq	.L33
.L32:
;$$fn 0x303
	jbsr	_tftp_in_char
	addq.l	#1,d0
	jne	.L32
.L33:
	move.l	_tftp_bytes_read,-(a7)
	lea	.L34,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#8,a7
	move.l	_tftp_nif,a0
	move.l	84(a0),a0
	move.l	_tftp_nif,-(a7)
	jbsr	(a0)
	addq.l	#4,a7
	moveq	#0,d0
	move.w	_tftp_localport,d0
	move.l	d0,-(a7)
;$$fn 0x303
	jbsr	_udp_free_port
	addq.l	#4,a7
;$$fn 0x303
	jbsr	_board_disable_interrupts
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_tftp_end,@function
	SIZE	_tftp_end,.-_tftp_end

; Allocations for _tftp_end
;	8(a6)	success

; Allocations for module
	LCOMM	_tftp_server,4
	LCOMM	_tftp_next_char,4
	LCOMM	_tftp_buf_length,4
	LCOMM	_tftp_buf_count,4
	LCOMM	_tftp_udpframe,4
	LCOMM	_tftp_ipframe,4
	LCOMM	_tftp_localport,2
	LCOMM	_tftp_nif,4
	LCOMM	_tftp_bytes_read,4
	ALIGN	4
.L4:
	ASCII	"octet"
	DC.B	0
	ALIGN	4
.L11:
	ASCII	"TFTP Error:  %d: "
	DC.B	0
	ALIGN	4
.L12:
	ASCII	"%s\n"
	DC.B	0
	ALIGN	4
.L23:
	ASCII	"udp_wait() timed out!\n"
	DC.B	0
	ALIGN	4
.L34:
	ASCII	"%d bytes read via TFTP\n"
	DC.B	0
	
