;$$p5200	- MCF5200 CPU
;$$o5200	- MCF5200 opt
;$$m4		- ELFEMB mnem.
;$$ko 0		- Reorder info
;$$sz 0		- Size opt info
	NAME	"history.c"
; -X options:
;$$x X1=4 X7=1 X8=1 X12=1 X15=2 X16=20 X17=1 X18=4
;$$x X19=1 X35=1 X39=5200 X44=1 X71=1 X74=5 X76=1 X80=1
;$$x X84=-2 X86=6 X91=1 X93=4 X111=1 X114=7 X116=1 X119=44
;$$x X201=136
	PSECT
;$$bf
	ALIGN	4
	XDEF	_history_init
_history_init:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
;$$er
	moveq	#0,d7
.L4:
	moveq	#5,d0
	cmp.l	d7,d0
	jle	.L2
	move.l	#_history,a0
	move.l	d7,d0
	lsl.l	#3,d0
	move.l	d0,d1
	lsl.l	#3,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.b	(a0)
	addq.l	#1,d7
	jra	.L4
.L2:
;$$be
;$$br
	move.l	-4(a6),d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_history_init,@function
	SIZE	_history_init,.-_history_init

; Allocations for _history_init
;	d7	index
;$$bf
	ALIGN	4
_history_down:
	link	a6,#-0
;$$br
	move.l	a5,-(a7)
	move.l	a4,-(a7)
;$$er
	move.l	8(a6),a5
	move.l	12(a6),a4
	subq.l	#1,(a5)
	tst.l	(a5)
	jpl	.L6
	moveq	#-1,d0
	move.l	d0,(a5)
	clr.b	(a4)
	moveq	#0,d0
	jra	.L5
.L6:
	move.l	(a5),d0
	lsl.l	#3,d0
	move.l	d0,d1
	lsl.l	#3,d0
	add.l	d0,d1
	move.l	#_history,d0
	add.l	d1,d0
	move.l	d0,-(a7)
	move.l	a4,-(a7)
;$$fn 0x303
	jbsr	_strcpy
	addq.l	#8,a7
	move.l	a4,-(a7)
	lea	.L7,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#8,a7
	move.l	a4,-(a7)
;$$fn 0x303
	jbsr	_strlen
	addq.l	#4,a7
.L5:
;$$be
;$$br
	movem.l	-8(a6),a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_history_down,@function
	SIZE	_history_down,.-_history_down

; Allocations for _history_down
;	a5	curr_hist
;	a4	line
;$$bf
	ALIGN	4
_history_up:
	link	a6,#-0
;$$br
	move.l	a5,-(a7)
	move.l	a4,-(a7)
;$$er
	move.l	8(a6),a5
	move.l	12(a6),a4
	move.l	(a5),d0
	addq.l	#1,d0
	jne	.L10
	clr.l	(a5)
	jra	.L11
.L10:
	addq.l	#1,(a5)
	move.l	(a5),d0
	subq.l	#5,d0
	jlt	.L11
	moveq	#4,d0
	move.l	d0,(a5)
.L11:
	move.l	(a5),d0
	lsl.l	#3,d0
	move.l	d0,d1
	lsl.l	#3,d0
	add.l	d0,d1
	move.l	#_history,d0
	add.l	d1,d0
	move.l	d0,-(a7)
	move.l	a4,-(a7)
;$$fn 0x303
	jbsr	_strcpy
	addq.l	#8,a7
	move.l	a4,-(a7)
	lea	.L7,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#8,a7
	move.l	a4,-(a7)
;$$fn 0x303
	jbsr	_strlen
	addq.l	#4,a7
;$$be
;$$br
	movem.l	-8(a6),a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_history_up,@function
	SIZE	_history_up,.-_history_up

; Allocations for _history_up
;	a5	curr_hist
;	a4	line
;$$bf
	ALIGN	4
_history_repeat:
	link	a6,#-0
;$$br
	move.l	a5,-(a7)
;$$er
	move.l	8(a6),a5
	move.l	#_history,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_strcpy
	addq.l	#8,a7
	move.l	a5,-(a7)
	lea	.L7,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#8,a7
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_strlen
	addq.l	#4,a7
;$$be
;$$br
	move.l	-4(a6),a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_history_repeat,@function
	SIZE	_history_repeat,.-_history_repeat

; Allocations for _history_repeat
;	a5	line
;$$bf
	ALIGN	4
_history_add:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
;$$er
	moveq	#4,d7
.L16:
	tst.l	d7
	jle	.L14
	move.l	d7,d0
	lsl.l	#3,d0
	move.l	d0,d1
	lsl.l	#3,d0
	add.l	d0,d1
	move.l	#_history,d0
	add.l	#-72,d0
	add.l	d1,d0
	move.l	d0,-(a7)
	move.l	d7,d0
	lsl.l	#3,d0
	move.l	d0,d1
	lsl.l	#3,d0
	add.l	d0,d1
	move.l	#_history,d0
	add.l	d1,d0
	move.l	d0,-(a7)
;$$fn 0x303
	jbsr	_strcpy
	addq.l	#8,a7
	subq.l	#1,d7
	jra	.L16
.L14:
	move.l	8(a6),-(a7)
	move.l	#_history,-(a7)
;$$fn 0x303
	jbsr	_strcpy
	addq.l	#8,a7
;$$be
;$$br
	move.l	-4(a6),d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_history_add,@function
	SIZE	_history_add,.-_history_add

; Allocations for _history_add
;	8(a6)	line
;	d7	index
;$$bf
	ALIGN	4
	XDEF	_get_history_line
_get_history_line:
	link	a6,#-80
	lea	-16(a7),a7
;$$br
	movem.l	d4/d5/d6/d7,(a7)
;$$er
	moveq	#-1,d0
	move.l	d0,-76(a6)
	moveq	#0,d4
	moveq	#0,d7
;$$fn 0x303
	jbsr	_board_in_char
	move.l	d0,d6
.L19:
	moveq	#13,d0
	cmp.l	d6,d0
	jeq	.L18
	moveq	#10,d0
	cmp.l	d6,d0
	jeq	.L18
	moveq	#72,d0
	cmp.l	d7,d0
	jle	.L18
	move.l	d6,d0
	add.l	#-18,d0
	jgt	.L39
	jeq	.L26
	add.l	#14,d0
	jeq	.L26
	subq.l	#4,d0
	jeq	.L22
	jra	.L33
.L39:
	subq.l	#3,d0
	jeq	.L26
	add.l	#-106,d0
	jeq	.L22
	jra	.L33
.L22:
	tst.l	d7
	jle	.L20
	subq.l	#1,d7
	pea	8.w
;$$fn 0x303
	jbsr	_board_out_char
	addq.l	#4,a7
	pea	32.w
;$$fn 0x303
	jbsr	_board_out_char
	addq.l	#4,a7
	pea	8.w
;$$fn 0x303
	jbsr	_board_out_char
	addq.l	#4,a7
	jra	.L20
.L26:
	moveq	#0,d5
.L29:
	cmp.l	d7,d5
	jge	.L27
	pea	8.w
;$$fn 0x303
	jbsr	_board_out_char
	addq.l	#4,a7
	pea	32.w
;$$fn 0x303
	jbsr	_board_out_char
	addq.l	#4,a7
	pea	8.w
;$$fn 0x303
	jbsr	_board_out_char
	addq.l	#4,a7
	addq.l	#1,d5
	jra	.L29
.L27:
	moveq	#21,d0
	cmp.l	d6,d0
	jne	.L30
	pea	-72(a6)
	pea	-76(a6)
;$$fn 0x303
	jbsr	_history_up
	addq.l	#8,a7
	move.l	d0,d7
	jra	.L20
.L30:
	moveq	#4,d0
	cmp.l	d6,d0
	jne	.L31
	pea	-72(a6)
	pea	-76(a6)
;$$fn 0x303
	jbsr	_history_down
	addq.l	#8,a7
	move.l	d0,d7
	jra	.L20
.L31:
	moveq	#18,d0
	cmp.l	d6,d0
	jne	.L20
	pea	-72(a6)
;$$fn 0x303
	jbsr	_history_repeat
	addq.l	#4,a7
	move.l	d0,d7
	moveq	#1,d4
	jra	.L20
.L33:
	move.l	d7,d0
	addq.l	#1,d0
	moveq	#72,d1
	cmp.l	d0,d1
	jle	.L20
	moveq	#-32,d0
	add.l	d6,d0
	moveq	#96,d1
	cmp.l	d0,d1
	jls	.L20
	move.b	d6,-72(a6,d7)
	addq.l	#1,d7
	move.l	d6,-(a7)
;$$fn 0x303
	jbsr	_board_out_char
	addq.l	#4,a7
.L20:
	tst.l	d4
	jne	.L18
;$$fn 0x303
	jbsr	_board_in_char
	move.l	d0,d6
	jra	.L19
.L18:
	clr.b	-72(a6,d7)
	pea	13.w
;$$fn 0x303
	jbsr	_board_out_char
	addq.l	#4,a7
	pea	10.w
;$$fn 0x303
	jbsr	_board_out_char
	addq.l	#4,a7
	pea	-72(a6)
;$$fn 0x303
	jbsr	_strlen
	addq.l	#4,a7
	tst.l	d0
	jeq	.L37
	tst.l	d4
	jne	.L37
	pea	-72(a6)
;$$fn 0x303
	jbsr	_history_add
	addq.l	#4,a7
.L37:
	pea	-72(a6)
	move.l	8(a6),-(a7)
;$$fn 0x303
	jbsr	_strcpy
	addq.l	#8,a7
	move.l	8(a6),d0
;$$be
;$$br
	movem.l	-96(a6),d4/d5/d6/d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_get_history_line,@function
	SIZE	_get_history_line,.-_get_history_line

; Allocations for _get_history_line
;	8(a6)	userline
;	-72(a6)	line
;	d7	pos
;	d6	ch
;	d5	i
;	-76(a6)	curr_hist
;	d4	repeat

; Allocations for module
	COMM	_history,360
	ALIGN	4
.L7:
	ASCII	"%s"
	DC.B	0
	
