;$$p5200	- MCF5200 CPU
;$$o5200	- MCF5200 opt
;$$m4		- ELFEMB mnem.
;$$ko 0		- Reorder info
;$$sz 0		- Size opt info
	NAME	"symtab.c"
; -X options:
;$$x X1=4 X7=1 X8=1 X12=1 X15=2 X16=20 X17=1 X18=4
;$$x X19=1 X35=1 X39=5200 X44=1 X71=1 X74=5 X76=1 X80=1
;$$x X84=-2 X86=6 X91=1 X93=4 X111=1 X114=7 X116=1 X119=44
;$$x X201=136
	PSECT
;$$bf
	ALIGN	4
	XDEF	_symtab_init
_symtab_init:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
;$$er
	clr.l	_symtab_in_use
	clr.l	_symtab_start
	moveq	#0,d7
.L4:
	cmp.l	#250,d7
	jge	.L2
	move.l	#_symtab,a0
	move.l	d7,d0
	lsl.l	#3,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
	move.l	#_symtab+36,a0
	move.l	d7,d0
	lsl.l	#3,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
	addq.l	#1,d7
	jra	.L4
.L2:
;$$be
;$$br
	move.l	-4(a6),d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_symtab_init,@function
	SIZE	_symtab_init,.-_symtab_init

; Allocations for _symtab_init
;	d7	index
;$$bf
	ALIGN	4
_symtab_ent_alloc:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
;$$er
	moveq	#0,d7
.L9:
	cmp.l	#250,d7
	jge	.L6
	move.l	#_symtab,a0
	move.l	d7,d0
	lsl.l	#3,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	tst.l	(a0)
	jne	.L8
	addq.l	#1,_symtab_in_use
	move.l	#_symtab,a0
	move.l	d7,d0
	lsl.l	#3,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	#16776960,d0
	move.l	d0,(a0)
	move.l	d7,d0
	lsl.l	#3,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	move.l	#_symtab,d0
	add.l	d1,d0
	jra	.L5
.L8:
	addq.l	#1,d7
	jra	.L9
.L6:
	moveq	#0,d0
.L5:
;$$be
;$$br
	move.l	-4(a6),d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_symtab_ent_alloc,@function
	SIZE	_symtab_ent_alloc,.-_symtab_ent_alloc

; Allocations for _symtab_ent_alloc
;	d7	index
;$$bf
	ALIGN	4
_symtab_ent_free:
	link	a6,#-0
	move.l	8(a6),a0
	clr.l	(a0)
	move.l	8(a6),a0
	clr.l	36(a0)
	subq.l	#1,_symtab_in_use
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_symtab_ent_free,@function
	SIZE	_symtab_ent_free,.-_symtab_ent_free

; Allocations for _symtab_ent_free
;	8(a6)	sp
;$$bf
	ALIGN	4
	XDEF	_symtab_find
_symtab_find:
	link	a6,#-0
;$$br
	move.l	a5,-(a7)
	move.l	a4,-(a7)
;$$er
	move.l	8(a6),a5
	move.l	_symtab_start,a4
.L13:
	tst.l	a4
	jeq	.L12
	pea	32.w
	move.l	a4,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_strncmp
	lea	12(a7),a7
	tst.l	d0
	jne	.L14
	move.l	a4,d0
	jra	.L11
.L14:
	move.l	36(a4),a4
	jra	.L13
.L12:
	moveq	#0,d0
.L11:
;$$be
;$$br
	movem.l	-8(a6),a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_symtab_find,@function
	SIZE	_symtab_find,.-_symtab_find

; Allocations for _symtab_find
;	a5	sym
;	a4	sp
;$$bf
	ALIGN	4
	XDEF	_symtab_convert_string
_symtab_convert_string:
	link	a6,#-0
;$$br
	move.l	a5,-(a7)
;$$er
	move.l	8(a6),-(a7)
;$$fn 0x303
	jbsr	_symtab_find
	addq.l	#4,a7
	move.l	d0,a5
	tst.l	a5
	jne	.L16
	moveq	#0,d0
	jra	.L15
.L16:
	move.l	12(a6),a0
	move.l	32(a5),(a0)
	moveq	#1,d0
.L15:
;$$be
;$$br
	move.l	-4(a6),a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_symtab_convert_string,@function
	SIZE	_symtab_convert_string,.-_symtab_convert_string

; Allocations for _symtab_convert_string
;	8(a6)	sym
;	12(a6)	symval
;	a5	sp
;$$bf
	ALIGN	4
	XDEF	_symtab_convert_address
_symtab_convert_address:
	link	a6,#-0
	lea	-12(a7),a7
;$$br
	movem.l	d7/a4/a5,(a7)
;$$er
	move.l	8(a6),d7
	move.l	12(a6),a5
	tst.l	_symtab_in_use
	jne	.L19
	move.l	d7,-(a7)
	lea	.L25,a0
	move.l	a0,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_sprintD
	lea	12(a7),a7
	moveq	#0,d0
	jra	.L18
.L19:
	move.l	_symtab_start,a4
.L21:
	tst.l	36(a4)
	jeq	.L20
	move.l	32(a4),d0
	and.l	#-1,d0
	move.l	d7,d1
	and.l	#-1,d1
	cmp.l	d1,d0
	jeq	.L20
	move.l	36(a4),a4
	jra	.L21
.L20:
	cmp.l	32(a4),d7
	jne	.L23
	pea	32.w
	move.l	a4,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_strncpy
	lea	12(a7),a7
	moveq	#1,d0
	jra	.L18
.L23:
	move.l	d7,-(a7)
	lea	.L25,a0
	move.l	a0,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_sprintD
	lea	12(a7),a7
	moveq	#0,d0
.L18:
;$$be
;$$br
	movem.l	-12(a6),d7/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_symtab_convert_address,@function
	SIZE	_symtab_convert_address,.-_symtab_convert_address

; Allocations for _symtab_convert_address
;	d7	address
;	a5	symstr
;	a4	curr
;$$bf
	ALIGN	4
_symtab_add_engine:
	link	a6,#-0
	lea	-16(a7),a7
;$$br
	movem.l	d7/a3/a4/a5,(a7)
;$$er
	move.l	12(a6),d7
;$$fn 0x103
	jbsr	_symtab_ent_alloc
	move.l	d0,a5
	tst.l	a5
	jne	.L27
	moveq	#0,d0
	jra	.L26
.L27:
	move.l	d7,32(a5)
	pea	32.w
	move.l	8(a6),-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_strncpy
	lea	12(a7),a7
	clr.b	31(a5)
	move.l	_symtab_start,a4
	tst.l	a4
	jne	.L28
	move.l	a5,_symtab_start
	clr.l	36(a5)
	move.l	a5,d0
	jra	.L26
.L28:
	cmp.l	32(a4),d7
	jcc	.L31
	move.l	_symtab_start,d0
	move.l	d0,36(a5)
	move.l	a5,_symtab_start
	move.l	a5,d0
	jra	.L26
.L31:
	tst.l	a4
	jeq	.L30
	move.l	36(a4),a3
	cmp.l	32(a4),d7
	jne	.L32
	move.l	a5,-(a7)
;$$fn 0x100
	jbsr	_symtab_ent_free
	addq.l	#4,a7
	moveq	#0,d0
	jra	.L26
.L32:
	tst.l	a3
	jne	.L33
	move.l	a5,36(a4)
	clr.l	36(a5)
	move.l	a5,d0
	jra	.L26
.L33:
	cmp.l	32(a4),d7
	jls	.L34
	cmp.l	32(a3),d7
	jcc	.L34
	move.l	36(a4),36(a5)
	move.l	a5,36(a4)
	move.l	a5,d0
	jra	.L26
.L34:
	move.l	a3,a4
	jra	.L31
.L30:
	move.l	a5,d0
.L26:
;$$be
;$$br
	movem.l	-16(a6),d7/a3/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_symtab_add_engine,@function
	SIZE	_symtab_add_engine,.-_symtab_add_engine

; Allocations for _symtab_add_engine
;	8(a6)	sym
;	d7	symval
;	a5	sp
;	a4	prev
;	a3	next
;$$bf
	ALIGN	4
	XDEF	_symtab_add
_symtab_add:
	link	a6,#-0
	move.l	12(a6),-(a7)
	move.l	8(a6),-(a7)
;$$fn 0x303
	jbsr	_symtab_add_engine
	addq.l	#8,a7
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_symtab_add,@function
	SIZE	_symtab_add,.-_symtab_add

; Allocations for _symtab_add
;	8(a6)	sym
;	12(a6)	symval
;$$bf
	ALIGN	4
	XDEF	_symtab_add_incomplete
_symtab_add_incomplete:
	link	a6,#-8
;$$br
	move.l	a5,-(a7)
;$$er
	move.l	#16776704,d0
	move.l	d0,-4(a6)
	move.l	12(a6),-(a7)
	pea	-4(a6)
;$$fn 0x303
	jbsr	_symtab_add_engine
	addq.l	#8,a7
	move.l	d0,a5
	tst.l	a5
	jeq	.L37
	move.l	#16776704,(a5)
	move.l	8(a6),4(a5)
.L37:
;$$be
;$$br
	move.l	-12(a6),a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_symtab_add_incomplete,@function
	SIZE	_symtab_add_incomplete,.-_symtab_add_incomplete

; Allocations for _symtab_add_incomplete
;	8(a6)	offset
;	12(a6)	symval
;	-4(a6)	inc
;	a5	sp
;$$bf
	ALIGN	4
	XDEF	_symtab_add_complete
_symtab_add_complete:
	link	a6,#-0
	lea	-12(a7),a7
;$$br
	movem.l	d7/a4/a5,(a7)
;$$er
	move.l	8(a6),a5
	move.l	12(a6),d7
	move.l	_symtab_start,a4
.L40:
	tst.l	a4
	jeq	.L39
	move.l	(a4),d0
	cmp.l	#16776704,d0
	jne	.L41
	cmp.l	4(a4),d7
	jne	.L41
	pea	32.w
	move.l	a5,-(a7)
	move.l	a4,-(a7)
;$$fn 0x303
	jbsr	_strncpy
	lea	12(a7),a7
	jra	.L39
.L41:
	move.l	36(a4),a4
	jra	.L40
.L39:
;$$be
;$$br
	movem.l	-12(a6),d7/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_symtab_add_complete,@function
	SIZE	_symtab_add_complete,.-_symtab_add_complete

; Allocations for _symtab_add_complete
;	a5	sym
;	d7	offset
;	a4	sp
;$$bf
	ALIGN	4
_symtab_remove:
	link	a6,#-0
;$$br
	move.l	a5,-(a7)
;$$er
	move.l	8(a6),a5
	cmp.l	_symtab_start,a5
	jne	.L43
	move.l	36(a5),d0
	move.l	d0,_symtab_start
	move.l	a5,-(a7)
;$$fn 0x100
	jbsr	_symtab_ent_free
	addq.l	#4,a7
	jra	.L42
.L43:
	move.l	_symtab_start,a1
.L45:
	tst.l	a1
	jeq	.L42
	cmp.l	36(a1),a5
	jne	.L46
	move.l	36(a5),36(a1)
	move.l	a5,-(a7)
;$$fn 0x100
	jbsr	_symtab_ent_free
	addq.l	#4,a7
	jra	.L42
.L46:
	move.l	36(a1),a1
	jra	.L45
.L42:
;$$be
;$$br
	move.l	-4(a6),a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_symtab_remove,@function
	SIZE	_symtab_remove,.-_symtab_remove

; Allocations for _symtab_remove
;	a5	sp
;	a1	prev
;$$bf
	ALIGN	4
_symtab_display:
	link	a6,#-8
;$$br
	move.l	a5,-(a7)
	move.l	a4,-(a7)
;$$er
	move.l	8(a6),a5
	clr.l	-4(a6)
	tst.l	a5
	jne	.L52
	move.l	_symtab_start,a4
.L49:
	tst.l	a4
	jeq	.L47
	move.l	a4,-(a7)
	move.l	32(a4),-(a7)
	lea	.L54,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	lea	12(a7),a7
	move.l	36(a4),a4
	pea	-4(a6)
;$$fn 0x303
	jbsr	_pause
	addq.l	#4,a7
	jra	.L49
.L52:
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_symtab_find
	addq.l	#4,a7
	move.l	d0,a4
	tst.l	a4
	jne	.L50
	move.l	a5,-(a7)
	lea	.L55,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#8,a7
	jra	.L47
.L50:
	move.l	(a4),d0
	cmp.l	#16776704,d0
	jeq	.L47
	move.l	a4,-(a7)
	move.l	32(a4),-(a7)
	lea	.L54,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	lea	12(a7),a7
.L47:
;$$be
;$$br
	movem.l	-16(a6),a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_symtab_display,@function
	SIZE	_symtab_display,.-_symtab_display

; Allocations for _symtab_display
;	a5	sym
;	-4(a6)	displayed
;	a4	sp
;$$bf
	ALIGN	4
	XDEF	_symbol
_symbol:
	link	a6,#-8
	lea	-20(a7),a7
;$$br
	movem.l	d5/d6/d7/a4/a5,(a7)
;$$er
	move.l	8(a6),d7
	move.l	12(a6),a5
	moveq	#1,d6
.L58:
	cmp.l	d7,d6
	jge	.L56
	move.l	(a5,d6*4),a0
	move.b	(a0),d0
	extb.l	d0
	moveq	#45,d1
	cmp.l	d0,d1
	jeq	.L78
	move.l	(a5,d6*4),-(a7)
;$$fn 0x303
	jbsr	_symtab_display
	addq.l	#4,a7
	jra	.L79
.L78:
	move.l	(a5,d6*4),a0
	move.b	1(a0),d0
	extb.l	d0
	cmp.l	#97,d0
	jgt	.L82
	jeq	.L61
	add.l	#-76,d0
	jgt	.L83
	jeq	.L70
	add.l	#11,d0
	jeq	.L61
	subq.l	#2,d0
	jeq	.L68
	jra	.L77
.L83:
	subq.l	#6,d0
	jeq	.L72
	subq.l	#1,d0
	jeq	.L76
	jra	.L77
.L82:
	add.l	#-99,d0
	jeq	.L68
	add.l	#-9,d0
	jeq	.L70
	subq.l	#6,d0
	jeq	.L72
	subq.l	#1,d0
	jeq	.L76
	jra	.L77
.L61:
	move.l	d6,d0
	addq.l	#2,d0
	cmp.l	d0,d7
	jgt	.L65
	lea	.L84,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#4,a7
	jra	.L56
.L65:
	move.l	_BASE,-(a7)
	pea	-4(a6)
	move.l	(8,a5,d6*4),-(a7)
;$$fn 0x303
	jbsr	_strtoul
	lea	12(a7),a7
	move.l	d0,d5
	tst.l	d5
	jne	.L62
	move.l	(4,a5,d6*4),a0
	cmp.l	-4(a6),a0
	jne	.L62
	move.l	(4,a5,d6*4),-(a7)
	lea	.L85,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#8,a7
.L62:
	move.l	(4,a5,d6*4),-(a7)
;$$fn 0x303
	jbsr	_symtab_find
	addq.l	#4,a7
	move.l	d0,a4
	tst.l	a4
	jne	.L63
	move.l	d5,-(a7)
	move.l	(4,a5,d6*4),-(a7)
;$$fn 0x303
	jbsr	_symtab_add
	addq.l	#8,a7
	jra	.L64
.L63:
	move.l	a4,-(a7)
;$$fn 0x301
	jbsr	_symtab_remove
	addq.l	#4,a7
	move.l	d5,-(a7)
	move.l	(4,a5,d6*4),-(a7)
;$$fn 0x303
	jbsr	_symtab_add
	addq.l	#8,a7
.L64:
	addq.l	#2,d6
	jra	.L79
.L68:
;$$fn 0x103
	jbsr	_symtab_init
	jra	.L56
.L70:
	clr.l	-(a7)
;$$fn 0x303
	jbsr	_symtab_display
	addq.l	#4,a7
	jra	.L56
.L72:
	addq.l	#1,d6
	move.l	(a5,d6*4),-(a7)
;$$fn 0x303
	jbsr	_symtab_find
	addq.l	#4,a7
	move.l	d0,a4
	tst.l	a4
	jne	.L73
	move.l	(a5,d6*4),-(a7)
	lea	.L86,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#8,a7
	jra	.L74
.L73:
	move.l	a4,-(a7)
;$$fn 0x301
	jbsr	_symtab_remove
	addq.l	#4,a7
.L74:
	addq.l	#1,d6
	jra	.L79
.L76:
	pea	250.w
	move.l	_symtab_in_use,-(a7)
	lea	.L87,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	lea	12(a7),a7
	jra	.L56
.L77:
	move.l	(a5,d6*4),-(a7)
	lea	.L88,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#8,a7
	jra	.L56
.L79:
	addq.l	#1,d6
	jra	.L58
.L56:
;$$be
;$$br
	movem.l	-28(a6),d5/d6/d7/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_symbol,@function
	SIZE	_symbol,.-_symbol

; Allocations for _symbol
;	d7	argc
;	a5	argv
;	d6	i
;	d5	symval
;	-4(a6)	p
;	a4	sp

; Allocations for module
	LCOMM	_symtab,10000
	LCOMM	_symtab_start,4
	LCOMM	_symtab_in_use,4
	ALIGN	4
.L25:
	ASCII	"0x%08X"
	DC.B	0
	ALIGN	4
.L54:
	ASCII	"%08X: %s\n"
	DC.B	0
	ALIGN	4
.L55:
	ASCII	"Error:  No such symbol:  %s\n"
	DC.B	0
	ALIGN	4
.L84:
	ASCII	"Error:  Invalid value\n"
	DC.B	0
	ALIGN	4
.L85:
	ASCII	"Error:  Invalid value:  %s\n"
	DC.B	0
	ALIGN	4
.L86:
	ASCII	"Error:  Invalid symbol:  %s\n"
	DC.B	0
	ALIGN	4
.L87:
	ASCII	"%d of %d symbol table entries in use.\n"
	DC.B	0
	ALIGN	4
.L88:
	ASCII	"Error:  Invalid option:  %s\n"
	DC.B	0
	
