;$$p5200	- MCF5200 CPU
;$$o5200	- MCF5200 opt
;$$m4		- ELFEMB mnem.
;$$ko 0		- Reorder info
;$$sz 0		- Size opt info
	NAME	"udp.c"
; -X options:
;$$x X1=4 X7=1 X8=1 X12=1 X15=2 X16=20 X17=1 X18=4
;$$x X19=1 X35=1 X39=5200 X44=1 X71=1 X74=5 X76=1 X80=1
;$$x X84=-2 X86=6 X91=1 X93=4 X111=1 X114=7 X116=1 X119=44
;$$x X201=136
	PSECT
;$$bf
	ALIGN	4
	XDEF	_udp_init
_udp_init:
	link	a6,#-0
	moveq	#0,d1
.L4:
	moveq	#5,d0
	cmp.l	d1,d0
	jle	.L2
	move.l	#_udp_port_table,a0
	move.l	d1,d0
	lsl.l	#3,d0
	add.l	d0,a0
	clr.w	(a0)
	addq.l	#1,d1
	jra	.L4
.L2:
	move.w	#17185,d0
	move.w	d0,_udp_port
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_udp_init,@function
	SIZE	_udp_init,.-_udp_init

; Allocations for _udp_init
;	d1	index
;$$bf
	ALIGN	4
	XDEF	_udp_bind_port
_udp_bind_port:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
;$$er
	move.w	10(a6),d7
	move.l	12(a6),a1
	moveq	#0,d1
.L9:
	moveq	#5,d0
	cmp.l	d1,d0
	jle	.L5
	move.l	#_udp_port_table,a0
	move.l	d1,d0
	lsl.l	#3,d0
	add.l	d0,a0
	moveq	#0,d0
	move.w	(a0),d0
	tst.l	d0
	jne	.L8
	move.l	#_udp_port_table,a0
	move.l	d1,d0
	lsl.l	#3,d0
	add.l	d0,a0
	move.w	d7,(a0)
	move.l	#_udp_port_table+4,a0
	move.l	d1,d0
	lsl.l	#3,d0
	add.l	d0,a0
	move.l	a1,(a0)
	jra	.L5
.L8:
	addq.l	#1,d1
	jra	.L9
.L5:
;$$be
;$$br
	move.l	-4(a6),d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_udp_bind_port,@function
	SIZE	_udp_bind_port,.-_udp_bind_port

; Allocations for _udp_bind_port
;	d7	port
;	a1	handler
;	d1	index
;$$bf
	ALIGN	4
	XDEF	_udp_free_port
_udp_free_port:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
;$$er
	move.w	10(a6),d7
	moveq	#0,d1
.L14:
	moveq	#5,d0
	cmp.l	d1,d0
	jle	.L10
	move.l	#_udp_port_table,a0
	move.l	d1,d0
	lsl.l	#3,d0
	add.l	d0,a0
	move.w	(a0),d0
	sub.l	d7,d0
	tst.w	d0
	jne	.L13
	move.l	#_udp_port_table,a0
	move.l	d1,d0
	lsl.l	#3,d0
	add.l	d0,a0
	clr.w	(a0)
	jra	.L10
.L13:
	addq.l	#1,d1
	jra	.L14
.L10:
;$$be
;$$br
	move.l	-4(a6),d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_udp_free_port,@function
	SIZE	_udp_free_port,.-_udp_free_port

; Allocations for _udp_free_port
;	d7	port
;	d1	index
;$$bf
	ALIGN	4
_udp_port_handler:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
;$$er
	move.w	10(a6),d7
	moveq	#0,d1
.L19:
	moveq	#5,d0
	cmp.l	d1,d0
	jle	.L16
	move.l	#_udp_port_table,a0
	move.l	d1,d0
	lsl.l	#3,d0
	add.l	d0,a0
	move.w	(a0),d0
	sub.l	d7,d0
	tst.w	d0
	jne	.L18
	move.l	#_udp_port_table+4,a0
	move.l	d1,d0
	lsl.l	#3,d0
	add.l	d0,a0
	move.l	(a0),d0
	jra	.L15
.L18:
	addq.l	#1,d1
	jra	.L19
.L16:
	moveq	#0,d0
.L15:
;$$be
;$$br
	move.l	-4(a6),d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_udp_port_handler,@function
	SIZE	_udp_port_handler,.-_udp_port_handler

; Allocations for _udp_port_handler
;	d7	port
;	d1	index
;$$bf
	ALIGN	4
	XDEF	_udp_obtain_free_port
_udp_obtain_free_port:
	link	a6,#-0
	moveq	#0,d1
	move.w	_udp_port,d1
	move.w	_udp_port,d0
	add.l	#65535,d0
	move.w	d0,_udp_port
	moveq	#0,d0
	move.w	_udp_port,d0
	cmp.l	#255,d0
	jgt	.L21
	move.w	#17185,d0
	move.w	d0,_udp_port
.L21:
	move.l	d1,d0
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_udp_obtain_free_port,@function
	SIZE	_udp_obtain_free_port,.-_udp_obtain_free_port

; Allocations for _udp_obtain_free_port
;	d1	port
;$$bf
	ALIGN	4
	XDEF	_udp_wait
_udp_wait:
	link	a6,#-0
	lea	-28(a7),a7
;$$br
	movem.l	d5/d6/d7/a2/a3/a4/a5,(a7)
;$$er
	move.l	12(a6),a4
	move.l	16(a6),d7
	move.l	20(a6),a3
	move.l	24(a6),d6
	moveq	#5,d5
	clr.l	(a3)
.L24:
	subq.l	#1,d5
	jeq	.L23
	move.l	d6,-(a7)
	pea	17.w
	move.l	a4,-(a7)
	move.l	8(a6),-(a7)
;$$fn 0x303
	jbsr	_ip_wait
	lea	16(a7),a7
	move.l	d0,a2
	tst.l	a2
	jne	.L25
	moveq	#0,d0
	jra	.L22
.L25:
	move.b	(a2),d0
	and.l	#15,d0
	lea	(a2,d0*4),a5
	moveq	#0,d0
	move.w	2(a5),d0
	cmp.l	d0,d7
	jne	.L26
	move.b	(a2),d0
	and.l	#15,d0
	lea	(a2,d0*4),a0
	move.l	a0,(a3)
	move.l	a2,d0
	jra	.L22
.L26:
	move.l	a2,a4
	jra	.L24
.L23:
	moveq	#0,d0
.L22:
;$$be
;$$br
	movem.l	-28(a6),d5/d6/d7/a2/a3/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_udp_wait,@function
	SIZE	_udp_wait,.-_udp_wait

; Allocations for _udp_wait
;	8(a6)	nif
;	a4	start
;	d7	port
;	a3	udpframep
;	d6	timeout
;	a2	ipframe
;	a5	udpframe
;	d5	num_tries
;$$bf
	ALIGN	4
	XDEF	_udp_send
_udp_send:
	link	a6,#-1504
	lea	-16(a7),a7
;$$br
	movem.l	d5/d6/d7/a5,(a7)
;$$er
	move.l	24(a6),a5
	move.l	28(a6),d7
	tst.l	d7
	jmi	.L32
	cmp.l	#1500,d7
	jle	.L28
.L32:
	moveq	#0,d0
	jra	.L27
.L28:
	move.l	16(a6),d0
	move.w	d0,-1500(a6)
	move.l	20(a6),d0
	move.w	d0,-1498(a6)
	move.l	d7,d0
	addq.l	#8,d0
	move.w	d0,-1496(a6)
	clr.w	-1494(a6)
	moveq	#0,d6
.L31:
	cmp.l	d7,d6
	jge	.L29
	move.l	a6,a0
	add.l	d6,a0
	move.b	0(a5,d6),d0
	move.b	d0,-1492(a0)
	addq.l	#1,d6
	jra	.L31
.L29:
	move.l	d7,a0
	pea	8(a0)
	pea	-1500(a6)
	pea	17.w
	pea	2048.w
	move.l	8(a6),-(a7)
;$$fn 0x303
	jbsr	_nif_proto_config
	addq.l	#8,a7
	move.l	d0,-(a7)
;$$fn 0x303
	jbsr	_proto_ip_get_pa
	addq.l	#4,a7
	move.l	d0,-(a7)
	move.l	12(a6),-(a7)
	move.l	8(a6),-(a7)
;$$fn 0x303
	jbsr	_ip_send
	lea	24(a7),a7
	move.l	d0,d5
	move.l	d5,d0
.L27:
;$$be
;$$br
	movem.l	-1520(a6),d5/d6/d7/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_udp_send,@function
	SIZE	_udp_send,.-_udp_send

; Allocations for _udp_send
;	8(a6)	nif
;	12(a6)	dest
;	16(a6)	sport
;	20(a6)	dport
;	a5	data
;	d7	length
;	-1500(a6)	datagram
;	d6	i
;	d5	retval
;$$bf
	ALIGN	4
	XDEF	_udp_handler
_udp_handler:
	link	a6,#-0
	lea	-16(a7),a7
;$$br
	movem.l	d7/a3/a4/a5,(a7)
;$$er
	move.l	16(a6),a4
	move.l	16(a6),a5
	addq.l	#8,a5
	move.w	2(a4),d0
	move.l	d0,-(a7)
;$$fn 0x103
	jbsr	_udp_port_handler
	addq.l	#4,a7
	move.l	d0,a3
	tst.l	a3
	jeq	.L34
	moveq	#0,d0
	move.w	4(a4),d0
	move.l	d0,-(a7)
	move.l	a5,-(a7)
	move.l	a4,-(a7)
	move.l	12(a6),-(a7)
	move.l	8(a6),-(a7)
	jbsr	(a3)
	lea	20(a7),a7
	move.l	d0,d7
	jra	.L35
.L34:
	moveq	#0,d7
.L35:
	move.l	d7,d0
;$$be
;$$br
	movem.l	-16(a6),d7/a3/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_udp_handler,@function
	SIZE	_udp_handler,.-_udp_handler

; Allocations for _udp_handler
;	8(a6)	nif
;	12(a6)	ipframe
;	16(a6)	data
;	not allocated	length
;	d7	keep
;	a5	udpdata
;	a4	udpframe
;	a3	handler

; Allocations for module
	LCOMM	_udp_port_table,40
	LCOMM	_udp_port,2
	
