;$$p5200	- MCF5200 CPU
;$$o5200	- MCF5200 opt
;$$m4		- ELFEMB mnem.
;$$ko 0		- Reorder info
;$$sz 0		- Size opt info
	NAME	"coff.c"
; -X options:
;$$x X1=4 X7=1 X8=1 X12=1 X15=2 X16=20 X17=1 X18=4
;$$x X19=1 X35=1 X39=5200 X44=1 X71=1 X74=5 X76=1 X80=1
;$$x X84=-2 X86=6 X91=1 X93=4 X111=1 X114=7 X116=1 X119=44
;$$x X201=136
	PSECT
;$$bf
	ALIGN	4
_coff_read:
	link	a6,#-0
	lea	-16(a7),a7
;$$br
	movem.l	d5/d6/d7/a5,(a7)
;$$er
	move.l	8(a6),d7
	move.l	12(a6),a5
	move.l	16(a6),d6
	moveq	#0,d5
.L4:
	cmp.l	d6,d5
	jge	.L2
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_board_next_char
	addq.l	#4,a7
	move.b	d0,0(a5,d5)
	addq.l	#1,_coff_bytes_read
	addq.l	#1,d5
	jra	.L4
.L2:
	move.l	d5,d0
;$$be
;$$br
	movem.l	-16(a6),d5/d6/d7/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_coff_read,@function
	SIZE	_coff_read,.-_coff_read

; Allocations for _coff_read
;	d7	iosource
;	a5	buf
;	d6	size
;	d5	i
;$$bf
	ALIGN	4
_coff_read_filehdr:
	link	a6,#-0
	pea	20.w
	move.l	12(a6),-(a7)
	move.l	8(a6),-(a7)
;$$fn 0x303
	jbsr	_coff_read
	lea	12(a7),a7
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_coff_read_filehdr,@function
	SIZE	_coff_read_filehdr,.-_coff_read_filehdr

; Allocations for _coff_read_filehdr
;	8(a6)	iosource
;	12(a6)	filehdr
;$$bf
	ALIGN	4
_coff_read_aouthdr:
	link	a6,#-0
	pea	28.w
	move.l	12(a6),-(a7)
	move.l	8(a6),-(a7)
;$$fn 0x303
	jbsr	_coff_read
	lea	12(a7),a7
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_coff_read_aouthdr,@function
	SIZE	_coff_read_aouthdr,.-_coff_read_aouthdr

; Allocations for _coff_read_aouthdr
;	8(a6)	iosource
;	12(a6)	aouthdr
;$$bf
	ALIGN	4
_coff_read_scnhdr:
	link	a6,#-0
	pea	40.w
	move.l	12(a6),-(a7)
	move.l	8(a6),-(a7)
;$$fn 0x303
	jbsr	_coff_read
	lea	12(a7),a7
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_coff_read_scnhdr,@function
	SIZE	_coff_read_scnhdr,.-_coff_read_scnhdr

; Allocations for _coff_read_scnhdr
;	8(a6)	iosource
;	12(a6)	scnhdr
;$$bf
	ALIGN	4
_coff_read_rawdata:
	link	a6,#-8
	lea	-12(a7),a7
;$$br
	movem.l	d6/d7/a5,(a7)
;$$er
	move.l	8(a6),d7
	move.l	12(a6),a5
	move.l	16(a5),-(a7)
	move.l	8(a5),-(a7)
	move.l	a5,-(a7)
	lea	.L22,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	lea	16(a7),a7
	move.l	_coff_bytes_read,d6
.L11:
	cmp.l	20(a5),d6
	jge	.L9
	pea	1.w
	pea	-1(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_coff_read
	lea	12(a7),a7
	addq.l	#1,d6
	jra	.L11
.L9:
	move.l	8(a5),-(a7)
;$$fn 0x303
	jbsr	_board_vda
	addq.l	#4,a7
	tst.l	d0
	jeq	.L20
	tst.b	39(a5)
	jmi	.L18
	moveq	#0,d6
.L14:
	cmp.l	16(a5),d6
	jge	.L8
	pea	1.w
	pea	-1(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_coff_read
	lea	12(a7),a7
	move.l	8(a5),a0
	add.l	d6,a0
	move.b	-1(a6),d0
	move.b	d0,(a0)
	addq.l	#1,d6
	jra	.L14
.L18:
	moveq	#0,d6
.L17:
	cmp.l	16(a5),d6
	jge	.L8
	move.l	8(a5),a0
	add.l	d6,a0
	clr.b	(a0)
	addq.l	#1,d6
	jra	.L17
.L20:
	move.l	8(a5),-(a7)
	lea	.L23,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#8,a7
.L8:
;$$be
;$$br
	movem.l	-20(a6),d6/d7/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_coff_read_rawdata,@function
	SIZE	_coff_read_rawdata,.-_coff_read_rawdata

; Allocations for _coff_read_rawdata
;	d7	iosource
;	a5	scnhdr
;	d6	i
;	-1(a6)	c
;$$bf
	ALIGN	4
_coff_read_syment:
	link	a6,#-16
	lea	-16(a7),a7
;$$br
	movem.l	d5/d6/d7/a5,(a7)
;$$er
	move.l	8(a6),d7
	move.l	12(a6),a5
	pea	18.w
	move.l	a5,-(a7)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_coff_read
	lea	12(a7),a7
	tst.l	(a5)
	jeq	.L33
	move.b	16(a5),d0
	extb.l	d0
	subq.l	#2,d0
	jne	.L34
	tst.b	17(a5)
	jne	.L34
	move.b	(a5),-12(a6)
	move.b	1(a5),-11(a6)
	move.b	2(a5),-10(a6)
	move.b	3(a5),-9(a6)
	move.b	4(a5),-8(a6)
	move.b	5(a5),-7(a6)
	move.b	6(a5),-6(a6)
	move.b	7(a5),-5(a6)
	clr.b	-4(a6)
	move.l	8(a5),-(a7)
	pea	-12(a6)
;$$fn 0x303
	jbsr	_symtab_add
	addq.l	#8,a7
	jra	.L34
.L33:
	move.b	16(a5),d0
	extb.l	d0
	subq.l	#2,d0
	jne	.L29
	tst.b	17(a5)
	jne	.L29
	move.l	8(a5),-(a7)
	move.l	4(a5),-(a7)
;$$fn 0x303
	jbsr	_symtab_add_incomplete
	addq.l	#8,a7
.L29:
	addq.l	#1,_coff_sym_incomplete
.L34:
	move.b	17(a5),d5
	extb.l	d5
	moveq	#0,d6
.L37:
	cmp.l	d5,d6
	jge	.L35
	pea	18.w
	move.l	a5,-(a7)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_coff_read
	lea	12(a7),a7
	subq.l	#1,_coff_numaux
	addq.l	#1,d6
	jra	.L37
.L35:
;$$be
;$$br
	movem.l	-32(a6),d5/d6/d7/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_coff_read_syment,@function
	SIZE	_coff_read_syment,.-_coff_read_syment

; Allocations for _coff_read_syment
;	d7	iosource
;	a5	syment
;	d6	i
;	d5	n_numaux
;	-12(a6)	symb
;$$bf
	ALIGN	4
	XDEF	_download_coff
_download_coff:
	link	a6,#-584
	lea	-20(a7),a7
;$$br
	movem.l	d3/d4/d5/d6/d7,(a7)
;$$er
	move.l	8(a6),d7
	clr.l	_coff_bytes_read
	pea	-20(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_coff_read_filehdr
	addq.l	#8,a7
	moveq	#0,d0
	move.w	-20(a6),d0
	add.l	#-336,d0
	jeq	.L39
	add.l	#-69,d0
	jeq	.L39
	subq.l	#3,d0
	jeq	.L39
	jra	.L43
	jra	.L39
.L43:
	moveq	#0,d0
	move.w	-20(a6),d0
	move.l	d0,-(a7)
	lea	.L71,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#8,a7
	jra	.L38
.L39:
	move.w	-2(a6),d0
	and.l	#2,d0
	subq.l	#2,d0
	jeq	.L44
	lea	.L72,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#4,a7
	jra	.L38
.L44:
	moveq	#0,d0
	move.w	-4(a6),d0
	moveq	#28,d1
	cmp.l	d0,d1
	jne	.L48
	pea	-48(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_coff_read_aouthdr
	addq.l	#8,a7
	move.l	-32(a6),-(a7)
;$$fn 0x303
	jbsr	_cpu_set_program_counter
	addq.l	#4,a7
	jra	.L49
.L48:
	moveq	#0,d6
.L47:
	moveq	#0,d0
	move.w	-4(a6),d0
	cmp.l	d0,d6
	jge	.L49
	pea	1.w
	pea	-72(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_coff_read
	lea	12(a7),a7
	addq.l	#1,d6
	jra	.L47
.L49:
	moveq	#0,d6
.L54:
	moveq	#0,d0
	move.w	-18(a6),d0
	cmp.l	d0,d6
	jge	.L50
	moveq	#9,d0
	cmp.l	d6,d0
	jle	.L52
	move.l	a6,a0
	move.l	d6,d0
	lsl.l	#3,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	pea	-480(a0)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_coff_read_scnhdr
	addq.l	#8,a7
	jra	.L53
.L52:
	pea	-80(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_coff_read_scnhdr
	addq.l	#8,a7
.L53:
	addq.l	#1,d6
	jra	.L54
.L50:
	moveq	#0,d6
.L57:
	moveq	#0,d0
	move.w	-18(a6),d0
	cmp.l	d0,d6
	jge	.L55
	move.l	a6,a0
	move.l	d6,d0
	lsl.l	#3,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	pea	-480(a0)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_coff_read_rawdata
	addq.l	#8,a7
	addq.l	#1,d6
	jra	.L57
.L55:
	move.l	_coff_bytes_read,d6
.L60:
	cmp.l	-12(a6),d6
	jge	.L58
	pea	1.w
	pea	-72(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_coff_read
	lea	12(a7),a7
	addq.l	#1,d6
	jra	.L60
.L58:
	clr.l	_coff_sym_incomplete
	tst.l	-8(a6)
	jeq	.L63
	move.l	-8(a6),d0
	move.l	d0,_coff_numaux
.L62:
	tst.l	_coff_numaux
	jeq	.L61
	subq.l	#1,_coff_numaux
	pea	-68(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_coff_read_syment
	addq.l	#8,a7
	jra	.L62
.L61:
	subq.l	#1,_coff_numaux
.L63:
	tst.l	_coff_sym_incomplete
	jeq	.L38
	move.l	_coff_bytes_read,d5
	pea	4.w
	pea	-76(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_coff_read
	lea	12(a7),a7
	moveq	#0,d6
.L69:
	cmp.l	_coff_sym_incomplete,d6
	jge	.L38
	move.l	_coff_bytes_read,d3
	sub.l	d5,d3
	moveq	#0,d4
.L67:
	pea	1.w
	pea	-77(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_coff_read
	lea	12(a7),a7
	move.l	a6,a0
	add.l	d4,a0
	move.b	-77(a6),d0
	move.b	d0,-580(a0)
	addq.l	#1,d4
	tst.b	-77(a6)
	jne	.L67
	move.l	d3,-(a7)
	pea	-580(a6)
;$$fn 0x303
	jbsr	_symtab_add_complete
	addq.l	#8,a7
	addq.l	#1,d6
	jra	.L69
.L38:
;$$be
;$$br
	movem.l	-604(a6),d3/d4/d5/d6/d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_download_coff,@function
	SIZE	_download_coff,.-_download_coff

; Allocations for _download_coff
;	d7	iosource
;	-20(a6)	filehdr
;	-48(a6)	aouthdr
;	-68(a6)	syment
;	d6	i
;	-72(a6)	c
;	-76(a6)	strtabsize
;	d5	strtaboffset
;	-77(a6)	ch
;	-480(a6)	scnhdr
;	d4	j
;	d3	offset
;	-580(a6)	sstr

; Allocations for module
	LCOMM	_coff_numaux,4
	LCOMM	_coff_bytes_read,4
	LCOMM	_coff_sym_incomplete,4
	ALIGN	4
.L22:
	ASCII	"Section:  %-8s (Paddr: 0x%08X  Size: 0x%08X)\n"
	DC.B	0
	ALIGN	4
.L23:
	ASCII	"Error: Invalid download address: %#08X\n"
	DC.B	0
	ALIGN	4
.L71:
	ASCII	"Error:  Not a recognized COFF format:  %04X\n"
	DC.B	0
	ALIGN	4
.L72:
	ASCII	"Error:  Not a COFF executable.\n"
	DC.B	0
	
