;$$p5200	- MCF5200 CPU
;$$o5200	- MCF5200 opt
;$$m4		- ELFEMB mnem.
;$$ko 0		- Reorder info
;$$sz 0		- Size opt info
	NAME	"elf.c"
; -X options:
;$$x X1=4 X7=1 X8=1 X12=1 X15=2 X16=20 X17=1 X18=4
;$$x X19=1 X35=1 X39=5200 X44=1 X71=1 X74=5 X76=1 X80=1
;$$x X84=-2 X86=6 X91=1 X93=4 X111=1 X114=7 X116=1 X119=44
;$$x X201=136
	PSECT
;$$bf
;$$v1
	ALIGN	4
_elf_read:
	link	a6,#-0
	lea	-16(a7),a7
;$$br
	movem.l	d5/d6/d7/a5,(a7)
;$$er
	move.l	8(a6),d7
	move.l	12(a6),a5
	move.l	16(a6),d6
	moveq	#0,d5
.L4:
	cmp.l	d6,d5
	jge	.L2
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_board_next_char
	addq.l	#4,a7
	move.b	d0,0(a5,d5)
	addq.l	#1,_elf_bytes_read
	addq.l	#1,d5
	jra	.L4
.L2:
;$$be
;$$br
	movem.l	-16(a6),d5/d6/d7/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_elf_read,@function
	SIZE	_elf_read,.-_elf_read

; Allocations for _elf_read
;	d7	iosource
;	a5	buf
;	d6	size
;	d5	i
;$$bf
	ALIGN	4
_elf_read_filehdr:
	link	a6,#-0
;$$br
	move.l	a5,-(a7)
;$$er
	move.l	12(a6),a5
	pea	52.w
	move.l	a5,-(a7)
	move.l	8(a6),-(a7)
;$$fn 0x303
	jbsr	_elf_read
	lea	12(a7),a7
	move.l	(a5),d0
	cmp.l	#2135247942,d0
	jeq	.L6
	move.l	(a5),-(a7)
	lea	.L7,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#8,a7
	moveq	#-1,d0
	jra	.L5
.L6:
	move.l	24(a5),-(a7)
;$$fn 0x303
	jbsr	_cpu_set_program_counter
	addq.l	#4,a7
	moveq	#1,d0
.L5:
;$$be
;$$br
	move.l	-4(a6),a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_elf_read_filehdr,@function
	SIZE	_elf_read_filehdr,.-_elf_read_filehdr

; Allocations for _elf_read_filehdr
;	8(a6)	iosource
;	a5	elfhdr
;$$bf
	ALIGN	4
_elf_read_pgmhdr:
	link	a6,#-0
	lea	-16(a7),a7
;$$br
	movem.l	d6/d7/a4/a5,(a7)
;$$er
	move.l	8(a6),d7
	move.l	12(a6),a5
	move.l	16(a6),a4
	moveq	#0,d6
.L11:
	moveq	#0,d0
	move.w	44(a5),d0
	cmp.l	d0,d6
	jge	.L9
	moveq	#0,d0
	move.w	42(a5),d0
	move.l	d0,-(a7)
	move.l	a4,-(a7)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_elf_read
	lea	12(a7),a7
	move.l	20(a4),-(a7)
	move.l	8(a4),-(a7)
	move.l	d6,-(a7)
	lea	.L12,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	lea	16(a7),a7
	lea	32(a4),a4
	addq.l	#1,d6
	jra	.L11
.L9:
;$$be
;$$br
	movem.l	-16(a6),d6/d7/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_elf_read_pgmhdr,@function
	SIZE	_elf_read_pgmhdr,.-_elf_read_pgmhdr

; Allocations for _elf_read_pgmhdr
;	d7	iosource
;	a5	elfhdr
;	a4	pgmhdr
;	d6	i
;$$bf
	ALIGN	4
_elf_read_rawdata:
	link	a6,#-8
	lea	-24(a7),a7
;$$br
	movem.l	d5/d6/d7/a3/a4/a5,(a7)
;$$er
	move.l	8(a6),d7
	move.l	12(a6),a5
	move.l	16(a6),a4
	moveq	#0,d6
.L21:
	moveq	#0,d0
	move.w	44(a5),d0
	cmp.l	d0,d6
	jge	.L13
	move.l	8(a4),-(a7)
;$$fn 0x303
	jbsr	_board_vda
	addq.l	#4,a7
	tst.l	d0
	jeq	.L19
	move.l	8(a4),a3
	moveq	#0,d5
.L18:
	cmp.l	16(a4),d5
	jcc	.L16
	pea	1.w
	pea	-1(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_elf_read
	lea	12(a7),a7
	move.b	-1(a6),(a3)+
	addq.l	#1,d5
	jra	.L18
.L16:
	lea	32(a4),a4
	jra	.L20
.L19:
	move.l	8(a4),-(a7)
	lea	.L22,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#8,a7
	jra	.L13
.L20:
	addq.l	#1,d6
	jra	.L21
.L13:
;$$be
;$$br
	movem.l	-32(a6),d5/d6/d7/a3/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_elf_read_rawdata,@function
	SIZE	_elf_read_rawdata,.-_elf_read_rawdata

; Allocations for _elf_read_rawdata
;	d7	iosource
;	a5	elfhdr
;	a4	pgmhdr
;	-1(a6)	c
;	a3	addr
;	d6	i
;	d5	j
;$$bf
;$$v1
	ALIGN	4
_elf_read_symtab:
	link	a6,#-16
;$$br
	move.l	a5,-(a7)
	move.l	d7,-(a7)
;$$er
	move.l	8(a6),d7
	move.l	12(a6),a5
.L25:
	move.l	20(a5),d0
	add.l	16(a5),d0
	cmp.l	_elf_bytes_read,d0
	jls	.L24
	pea	16.w
	pea	-16(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_elf_read
	lea	12(a7),a7
	moveq	#0,d0
	move.b	-4(a6),d0
	asr.l	#4,d0
	subq.l	#1,d0
	jne	.L25
	move.b	-4(a6),d0
	and.l	#15,d0
	subq.l	#1,d0
	jeq	.L27
	move.b	-4(a6),d0
	and.l	#15,d0
	tst.b	d0
	jeq	.L27
	move.b	-4(a6),d0
	and.l	#15,d0
	subq.l	#2,d0
	jne	.L25
.L27:
	move.l	-12(a6),-(a7)
	move.l	-16(a6),-(a7)
;$$fn 0x303
	jbsr	_symtab_add_incomplete
	addq.l	#8,a7
	jra	.L25
.L24:
;$$be
;$$br
	movem.l	-24(a6),d7/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_elf_read_symtab,@function
	SIZE	_elf_read_symtab,.-_elf_read_symtab

; Allocations for _elf_read_symtab
;	d7	iosource
;	a5	scnhdr
;	-16(a6)	syment
;$$bf
	ALIGN	4
_elf_read_scnhdr:
	link	a6,#-0
	lea	-16(a7),a7
;$$br
	movem.l	d6/d7/a4/a5,(a7)
;$$er
	move.l	8(a6),d7
	move.l	12(a6),a5
	move.l	16(a6),a4
	clr.l	_symndx
	clr.l	_strndx
	clr.l	_symoff
	clr.l	_stroff
	moveq	#0,d6
.L34:
	moveq	#0,d0
	move.w	48(a5),d0
	cmp.l	d0,d6
	jge	.L29
	pea	40.w
	move.l	a4,-(a7)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_elf_read
	lea	12(a7),a7
	move.l	4(a4),d0
	subq.l	#2,d0
	jne	.L31
	tst.l	_symndx
	jne	.L31
	move.l	16(a4),d0
	move.l	d0,_symoff
	move.l	d6,_symndx
.L31:
	move.l	4(a4),d0
	subq.l	#3,d0
	jne	.L32
	tst.l	_strndx
	jne	.L32
	moveq	#0,d0
	move.w	50(a5),d0
	cmp.l	d0,d6
	jeq	.L32
	move.l	16(a4),d0
	move.l	d0,_stroff
	move.l	d6,_strndx
.L32:
	moveq	#20,d0
	cmp.l	d6,d0
	jle	.L33
	lea	40(a4),a4
.L33:
	addq.l	#1,d6
	jra	.L34
.L29:
	tst.l	_symndx
	jeq	.L38
	tst.l	_strndx
	jne	.L35
.L38:
	moveq	#0,d0
	jra	.L28
.L35:
	move.l	_symndx,d0
	cmp.l	_strndx,d0
	slt	d0
	and.l	#1,d0
.L28:
;$$be
;$$br
	movem.l	-16(a6),d6/d7/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_elf_read_scnhdr,@function
	SIZE	_elf_read_scnhdr,.-_elf_read_scnhdr

; Allocations for _elf_read_scnhdr
;	d7	iosource
;	a5	elfhdr
;	a4	scnhdr
;	d6	i
;$$bf
;$$v1
	ALIGN	4
	XDEF	_elf_read_strtab
_elf_read_strtab:
	link	a6,#-104
	lea	-20(a7),a7
;$$br
	movem.l	d5/d6/d7/a4/a5,(a7)
;$$er
	move.l	8(a6),d7
	move.l	12(a6),a5
.L41:
	move.l	20(a5),d0
	add.l	16(a5),d0
	cmp.l	_elf_bytes_read,d0
	jls	.L40
	lea	-100(a6),a4
	moveq	#0,d6
	move.l	_elf_bytes_read,d5
	sub.l	16(a5),d5
	moveq	#88,d0
	move.b	d0,-101(a6)
.L43:
	tst.b	-101(a6)
	jeq	.L42
	pea	1.w
	pea	-101(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_elf_read
	lea	12(a7),a7
	addq.l	#1,d6
	moveq	#100,d0
	cmp.l	d6,d0
	jle	.L44
	move.b	-101(a6),(a4)+
	jra	.L43
.L44:
	clr.b	(a4)
	jra	.L43
.L42:
	move.l	d5,-(a7)
	pea	-100(a6)
;$$fn 0x303
	jbsr	_symtab_add_complete
	addq.l	#8,a7
	jra	.L41
.L40:
;$$be
;$$br
	movem.l	-124(a6),d5/d6/d7/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_elf_read_strtab,@function
	SIZE	_elf_read_strtab,.-_elf_read_strtab

; Allocations for _elf_read_strtab
;	d7	iosource
;	a5	scnhdr
;	d6	i
;	d5	offset
;	-100(a6)	buffer
;	a4	p
;	-101(a6)	c
;$$bf
;$$v1
	ALIGN	4
	XDEF	_download_elf
_download_elf:
	link	a6,#-8
;$$br
	move.l	d7,-(a7)
	move.l	d6,-(a7)
;$$er
	move.l	8(a6),d7
	clr.l	_elf_bytes_read
	move.l	12(a6),d0
	subq.l	#1,d0
	jne	.L68
	move.l	#_elfhdr,-(a7)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_elf_read_filehdr
	addq.l	#8,a7
	subq.l	#1,d0
	jeq	.L47
	moveq	#-1,d0
	jra	.L46
.L47:
	move.w	_elfhdr+16,d0
	and.l	#2,d0
	tst.l	d0
	jne	.L48
	lea	.L71,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#4,a7
	moveq	#-1,d0
	jra	.L46
.L48:
	moveq	#0,d0
	move.w	_elfhdr+44,d0
	moveq	#20,d1
	cmp.l	d0,d1
	jle	.L70
	moveq	#0,d0
	move.w	_elfhdr+48,d0
	moveq	#20,d1
	cmp.l	d0,d1
	jgt	.L49
.L70:
	lea	.L72,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#4,a7
	moveq	#-1,d0
	jra	.L46
.L49:
	tst.l	_elfhdr+28
	jeq	.L53
	move.l	_elf_bytes_read,d6
.L52:
	cmp.l	_elfhdr+28,d6
	jcc	.L50
	pea	1.w
	pea	-1(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_elf_read
	lea	12(a7),a7
	addq.l	#1,d6
	jra	.L52
.L50:
	move.l	#_pgmhdr,-(a7)
	move.l	#_elfhdr,-(a7)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_elf_read_pgmhdr
	lea	12(a7),a7
.L53:
	move.l	_elf_bytes_read,d6
.L56:
	cmp.l	_pgmhdr+4,d6
	jcc	.L54
	pea	1.w
	pea	-1(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_elf_read
	lea	12(a7),a7
	addq.l	#1,d6
	jra	.L56
.L54:
	move.l	#_pgmhdr,-(a7)
	move.l	#_elfhdr,-(a7)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_elf_read_rawdata
	lea	12(a7),a7
	tst.l	_elfhdr+32
	jeq	.L60
	move.l	_elf_bytes_read,d6
.L59:
	cmp.l	_elfhdr+32,d6
	jcc	.L57
	pea	1.w
	pea	-1(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_elf_read
	lea	12(a7),a7
	addq.l	#1,d6
	jra	.L59
.L57:
	move.l	#_scnhdr,-(a7)
	move.l	#_elfhdr,-(a7)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_elf_read_scnhdr
	lea	12(a7),a7
	move.l	d0,_have_symtab
	moveq	#1,d0
	jra	.L46
.L60:
	moveq	#0,d0
	jra	.L46
.L68:
	move.l	_elf_bytes_read,d6
.L64:
	cmp.l	_symoff,d6
	jge	.L62
	pea	1.w
	pea	-1(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_elf_read
	lea	12(a7),a7
	addq.l	#1,d6
	jra	.L64
.L62:
	move.l	_symndx,d0
	lsl.l	#3,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	move.l	#_scnhdr,d0
	add.l	d1,d0
	move.l	d0,-(a7)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_elf_read_symtab
	addq.l	#8,a7
	move.l	_elf_bytes_read,d6
.L67:
	cmp.l	_stroff,d6
	jge	.L65
	pea	1.w
	pea	-1(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_elf_read
	lea	12(a7),a7
	addq.l	#1,d6
	jra	.L67
.L65:
	move.l	_strndx,d0
	lsl.l	#3,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	move.l	#_scnhdr,d0
	add.l	d1,d0
	move.l	d0,-(a7)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_elf_read_strtab
	addq.l	#8,a7
	moveq	#1,d0
.L46:
;$$be
;$$br
	movem.l	-16(a6),d6/d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_download_elf,@function
	SIZE	_download_elf,.-_download_elf

; Allocations for _download_elf
;	d7	iosource
;	12(a6)	passno
;	d6	i
;	-1(a6)	c

; Allocations for module
	LCOMM	_elf_bytes_read,4
	LCOMM	_symndx,4
	LCOMM	_strndx,4
	LCOMM	_symoff,4
	LCOMM	_stroff,4
	LCOMM	_elfhdr,52
	LCOMM	_pgmhdr,640
	LCOMM	_scnhdr,800
	LCOMM	_have_symtab,4
	ALIGN	4
.L7:
	ASCII	"Error:  Not a recognized ELF format:  %08X\n"
	DC.B	0
	ALIGN	4
.L12:
	ASCII	"Segment #%d  (Vaddr: 0x%08X  Size: 0x%08X)\n"
	DC.B	0
	ALIGN	4
.L22:
	ASCII	"Error: Invalid download address: %#08X\n"
	DC.B	0
	ALIGN	4
.L71:
	ASCII	"Not an executable!\n"
	DC.B	0
	ALIGN	4
.L72:
	ASCII	"Error:  Too many Headers\n"
	DC.B	0
	
