/*
 * File:		isr.h
 * Purpose:		General purpose include file
 *
 * Notes:
 *
 * Date:		11-8-95
 *
 * Modifications:
 *
 */


#ifndef _ISR_H
#define _ISR_H

#define ISR_DBUG_ISR		(0x01)
#define ISR_USER_ISR		(0x02)

void
isr_init (void);

int
isr_register_handler (int, int,
	int (*)(void *, void *), void *, void *);

void
isr_remove_handler (int (*)(void *, void *));

int
isr_execute_handler (int);


#endif	/* _ISR_H */
