;$$p5200	- MCF5200 CPU
;$$o5200	- MCF5200 opt
;$$m4		- ELFEMB mnem.
;$$ko 0		- Reorder info
;$$sz 0		- Size opt info
	NAME	"isr.c"
; -X options:
;$$x X1=4 X7=1 X8=1 X12=1 X15=2 X16=20 X17=1 X18=4
;$$x X19=1 X35=1 X39=5200 X44=1 X71=1 X74=5 X76=1 X80=1
;$$x X84=-2 X86=6 X91=1 X93=4 X111=1 X114=7 X116=1 X119=44
;$$x X201=136
	PSECT
;$$bf
	ALIGN	4
	XDEF	_isr_init
_isr_init:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
;$$er
	moveq	#0,d7
.L4:
	moveq	#10,d0
	cmp.l	d7,d0
	jle	.L2
	move.l	#_isrtab,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
	move.l	#_isrtab+4,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
	move.l	#_isrtab+8,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
	move.l	#_isrtab+12,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
	move.l	#_isrtab+16,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
	addq.l	#1,d7
	jra	.L4
.L2:
;$$be
;$$br
	move.l	-4(a6),d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_isr_init,@function
	SIZE	_isr_init,.-_isr_init

; Allocations for _isr_init
;	d7	index
;$$bf
	ALIGN	4
	XDEF	_isr_register_handler
_isr_register_handler:
	link	a6,#-0
	lea	-20(a7),a7
;$$br
	movem.l	d5/d6/d7/a4/a5,(a7)
;$$er
	move.l	8(a6),d7
	move.l	12(a6),d6
	move.l	16(a6),a5
	move.l	20(a6),a4
	move.l	24(a6),a1
	tst.l	d6
	jeq	.L12
	moveq	#1,d0
	cmp.l	d7,d0
	jeq	.L13
	moveq	#2,d0
	cmp.l	d7,d0
	jne	.L12
.L13:
	tst.l	a5
	jne	.L6
.L12:
	moveq	#0,d0
	jra	.L5
.L6:
	moveq	#0,d5
.L11:
	moveq	#10,d0
	cmp.l	d5,d0
	jle	.L7
	move.l	#_isrtab,a0
	move.l	d5,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	cmp.l	(a0),d6
	jne	.L9
	move.l	#_isrtab+4,a0
	move.l	d5,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	cmp.l	(a0),d7
	jne	.L9
	moveq	#0,d0
	jra	.L5
.L9:
	move.l	#_isrtab,a0
	move.l	d5,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	tst.l	(a0)
	jne	.L10
	move.l	#_isrtab,a0
	move.l	d5,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	d6,(a0)
	move.l	#_isrtab+4,a0
	move.l	d5,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	d7,(a0)
	move.l	#_isrtab+8,a0
	move.l	d5,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	a5,(a0)
	move.l	#_isrtab+12,a0
	move.l	d5,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	a4,(a0)
	move.l	#_isrtab+16,a0
	move.l	d5,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	a1,(a0)
	moveq	#1,d0
	jra	.L5
.L10:
	addq.l	#1,d5
	jra	.L11
.L7:
	moveq	#0,d0
.L5:
;$$be
;$$br
	movem.l	-20(a6),d5/d6/d7/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_isr_register_handler,@function
	SIZE	_isr_register_handler,.-_isr_register_handler

; Allocations for _isr_register_handler
;	d7	type
;	d6	vector
;	a5	handler
;	a4	hdev
;	a1	harg
;	d5	index
;$$bf
	ALIGN	4
	XDEF	_isr_remove_handler
_isr_remove_handler:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
;$$er
	move.l	8(a6),a1
	moveq	#0,d7
.L18:
	moveq	#10,d0
	cmp.l	d7,d0
	jle	.L15
	move.l	#_isrtab+8,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	cmp.l	(a0),a1
	jne	.L17
	move.l	#_isrtab,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
	move.l	#_isrtab+4,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
	move.l	#_isrtab+8,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
	move.l	#_isrtab+12,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
	move.l	#_isrtab+16,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
	jra	.L15
.L17:
	addq.l	#1,d7
	jra	.L18
.L15:
;$$be
;$$br
	move.l	-4(a6),d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_isr_remove_handler,@function
	SIZE	_isr_remove_handler,.-_isr_remove_handler

; Allocations for _isr_remove_handler
;	a1	handler
;	d7	index
;$$bf
	ALIGN	4
	XDEF	_isr_execute_handler
_isr_execute_handler:
	link	a6,#-0
	lea	-12(a7),a7
;$$br
	movem.l	d5/d6/d7,(a7)
;$$er
	move.l	8(a6),d7
	moveq	#0,d5
	moveq	#0,d6
.L24:
	moveq	#10,d0
	cmp.l	d6,d0
	jle	.L20
	move.l	#_isrtab,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	cmp.l	(a0),d7
	jne	.L23
	move.l	#_isrtab+4,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	(a0),d0
	subq.l	#1,d0
	jne	.L23
	move.l	#_isrtab+8,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	(a0),a0
	move.l	#_isrtab+16,a1
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a1
	move.l	(a1),-(a7)
	move.l	#_isrtab+12,a1
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a1
	move.l	(a1),-(a7)
	jbsr	(a0)
	addq.l	#8,a7
	tst.l	d0
	jeq	.L23
	moveq	#1,d5
	jra	.L20
.L23:
	addq.l	#1,d6
	jra	.L24
.L20:
	moveq	#0,d6
.L29:
	moveq	#10,d0
	cmp.l	d6,d0
	jle	.L25
	move.l	#_isrtab,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	cmp.l	(a0),d7
	jne	.L28
	move.l	#_isrtab+4,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	(a0),d0
	subq.l	#2,d0
	jne	.L28
	move.l	#_isrtab+8,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	(a0),a0
	move.l	#_isrtab+16,a1
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a1
	move.l	(a1),-(a7)
	move.l	#_isrtab+12,a1
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a1
	move.l	(a1),-(a7)
	jbsr	(a0)
	addq.l	#8,a7
	tst.l	d0
	jeq	.L28
	moveq	#1,d5
	jra	.L25
.L28:
	addq.l	#1,d6
	jra	.L29
.L25:
	move.l	d5,d0
;$$be
;$$br
	movem.l	-12(a6),d5/d6/d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_isr_execute_handler,@function
	SIZE	_isr_execute_handler,.-_isr_execute_handler

; Allocations for _isr_execute_handler
;	d7	vector
;	d6	index
;	d5	retval

; Allocations for module
	COMM	_isrtab,200
	
