;$$p5200	- MCF5200 CPU
;$$o5200	- MCF5200 opt
;$$m4		- ELFEMB mnem.
;$$ko 0		- Reorder info
;$$sz 0		- Size opt info
	NAME	"printk.c"
; -X options:
;$$x X1=4 X7=1 X8=1 X12=1 X15=2 X16=20 X17=1 X18=4
;$$x X19=1 X35=1 X39=5200 X44=1 X71=1 X74=5 X76=1 X80=1
;$$x X84=-2 X86=6 X91=1 X93=4 X111=1 X114=7 X116=1 X119=44
;$$x X201=136
	PSECT
;$$bf
	ALIGN	4
_printk_putc:
	link	a6,#-0
;$$br
	move.l	a5,-(a7)
;$$er
	move.l	16(a6),a5
	move.l	(a5),d0
	subq.l	#1,d0
	jeq	.L3
	subq.l	#1,d0
	jeq	.L4
	jra	.L2
.L3:
	move.l	4(a5),a0
	move.l	8(a6),-(a7)
	jbsr	(a0)
	addq.l	#4,a7
	jra	.L2
.L4:
	move.l	8(a5),a0
	move.l	8(a6),d0
	move.b	d0,(a0)
	addq.l	#1,8(a5)
.L2:
	move.l	12(a6),a0
	addq.l	#1,(a0)
;$$be
;$$br
	move.l	-4(a6),a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_printk_putc,@function
	SIZE	_printk_putc,.-_printk_putc

; Allocations for _printk_putc
;	8(a6)	c
;	12(a6)	count
;	a5	info
;$$bf
	ALIGN	4
_printk_mknumstr:
	link	a6,#-8
	lea	-28(a7),a7
;$$br
	movem.l	d2/d3/d4/d5/d6/d7/a5,(a7)
;$$er
	move.l	20(a6),d7
	moveq	#0,d2
	move.l	8(a6),a5
	clr.b	(a5)+
	tst.l	16(a6)
	jeq	.L18
	move.l	12(a6),a0
	move.l	(a0),d6
	jne	.L10
	moveq	#48,d0
	move.b	d0,(a5)+
	addq.l	#1,d2
	jra	.L7
.L10:
	tst.l	d6
	jeq	.L7
	move.l	d6,d0
	move.l	d7,d1
	jbsr	ldivd
	move.l	d0,-4(a6)
	move.l	d7,d1
	muls.l	-4(a6),d1
	move.l	d6,d4
	sub.l	d1,d4
	tst.l	d4
	jpl	.L11
	not.l	d4
	add.l	#49,d4
	jra	.L12
.L11:
	add.l	#48,d4
.L12:
	move.l	-4(a6),d6
	move.b	d4,(a5)+
	addq.l	#1,d2
	jra	.L10
.L18:
	move.l	12(a6),a0
	move.l	(a0),d3
	jne	.L15
	moveq	#48,d0
	move.b	d0,(a5)+
	addq.l	#1,d2
	jra	.L7
.L15:
	tst.l	d3
	jeq	.L7
	move.l	d3,d0
	move.l	d7,d1
	jbsr	uldivd
	move.l	d0,-8(a6)
	move.l	d7,d1
	muls.l	-8(a6),d1
	move.l	d3,d5
	sub.l	d1,d5
	moveq	#10,d0
	cmp.l	d5,d0
	jls	.L16
	add.l	#48,d5
	jra	.L17
.L16:
	add.l	#55,d5
.L17:
	move.l	-8(a6),d3
	move.b	d5,(a5)+
	addq.l	#1,d2
	jra	.L15
.L7:
	move.l	d2,d0
;$$be
;$$br
	movem.l	-36(a6),d2/d3/d4/d5/d6/d7/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_printk_mknumstr,@function
	SIZE	_printk_mknumstr,.-_printk_mknumstr

; Allocations for _printk_mknumstr
;	8(a6)	numstr
;	12(a6)	nump
;	16(a6)	neg
;	d7	radix
;	d6	a
;	-4(a6)	b
;	d4	c
;	d3	ua
;	-8(a6)	ub
;	d5	uc
;	d2	nlen
;	a5	nstrp
;$$bf
	ALIGN	4
_printk_pad_zero:
	link	a6,#-0
	lea	-16(a7),a7
;$$br
	movem.l	d6/d7/a4/a5,(a7)
;$$er
	move.l	12(a6),d7
	move.l	16(a6),a5
	move.l	20(a6),a4
	move.l	8(a6),d6
.L23:
	cmp.l	d7,d6
	jge	.L21
	move.l	a4,-(a7)
	move.l	a5,-(a7)
	pea	48.w
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
	addq.l	#1,d6
	jra	.L23
.L21:
;$$be
;$$br
	movem.l	-16(a6),d6/d7/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_printk_pad_zero,@function
	SIZE	_printk_pad_zero,.-_printk_pad_zero

; Allocations for _printk_pad_zero
;	8(a6)	curlen
;	d7	field_width
;	a5	count
;	a4	info
;	d6	i
;$$bf
	ALIGN	4
_printk_pad_space:
	link	a6,#-0
	lea	-16(a7),a7
;$$br
	movem.l	d6/d7/a4/a5,(a7)
;$$er
	move.l	12(a6),d7
	move.l	16(a6),a5
	move.l	20(a6),a4
	move.l	8(a6),d6
.L27:
	cmp.l	d7,d6
	jge	.L25
	move.l	a4,-(a7)
	move.l	a5,-(a7)
	pea	32.w
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
	addq.l	#1,d6
	jra	.L27
.L25:
;$$be
;$$br
	movem.l	-16(a6),d6/d7/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_printk_pad_space,@function
	SIZE	_printk_pad_space,.-_printk_pad_space

; Allocations for _printk_pad_space
;	8(a6)	curlen
;	d7	field_width
;	a5	count
;	a4	info
;	d6	i
;$$bf
	ALIGN	4
	XDEF	_printk
_printk:
	link	a6,#-72
	lea	-40(a7),a7
;$$br
	movem.l	d2/d3/d4/d5/d6/d7/a2/a3/a4/a5,(a7)
;$$er
	move.l	8(a6),a5
	clr.l	-40(a6)
	move.l	12(a6),a3
.L123:
	move.b	(a3),d7
	extb.l	d7
	tst.l	d7
	jeq	.L29
	moveq	#37,d0
	cmp.l	d7,d0
	jeq	.L33
	moveq	#10,d0
	cmp.l	d7,d0
	jeq	.L31
	move.l	a5,-(a7)
	pea	-40(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
	jra	.L30
.L31:
	move.l	a5,-(a7)
	pea	-40(a6)
	pea	13.w
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
	move.l	a5,-(a7)
	pea	-40(a6)
	pea	10.w
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
	jra	.L30
.L33:
	moveq	#0,d4
	moveq	#0,d5
.L35:
	tst.l	d5
	jne	.L34
	addq.l	#1,a3
	move.b	(a3),d7
	extb.l	d7
	move.l	d7,d0
	add.l	#-43,d0
	jgt	.L128
	jeq	.L38
	add.l	#11,d0
	jeq	.L39
	subq.l	#3,d0
	jeq	.L41
	jra	.L42
.L128:
	subq.l	#2,d0
	jeq	.L37
	subq.l	#3,d0
	jeq	.L40
	jra	.L42
.L37:
	or.l	#1,d4
	jra	.L35
.L38:
	or.l	#2,d4
	jra	.L35
.L39:
	or.l	#4,d4
	jra	.L35
.L40:
	or.l	#8,d4
	jra	.L35
.L41:
	or.l	#16,d4
	jra	.L35
.L42:
	subq.l	#1,a3
	moveq	#1,d5
	jra	.L35
.L34:
	moveq	#0,d3
	moveq	#0,d5
.L44:
	tst.l	d5
	jne	.L43
	addq.l	#1,a3
	move.b	(a3),d7
	extb.l	d7
	move.l	d7,d0
	sub.l	#48,d0
	cmp.l	#9,d0
	jhi	.L56
	move.l	(4,pc,d0.l*4),a0
;$$sw
	jmp	(a0)
.L129:
	DC.L	.L55
	DC.L	.L55
	DC.L	.L55
	DC.L	.L55
	DC.L	.L55
	DC.L	.L55
	DC.L	.L55
	DC.L	.L55
	DC.L	.L55
	DC.L	.L55
;$$se
.L55:
	move.l	d3,d0
	add.l	d0,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d7,d1
	add.l	#-48,d1
	move.l	d1,d3
	jra	.L44
.L56:
	subq.l	#1,a3
	moveq	#1,d5
	jra	.L44
.L43:
	addq.l	#1,a3
	move.b	(a3),d7
	extb.l	d7
	moveq	#46,d0
	cmp.l	d7,d0
	jne	.L71
	moveq	#1,d0
	move.l	d0,-44(a6)
	moveq	#0,d2
	moveq	#0,d5
.L58:
	tst.l	d5
	jne	.L72
	addq.l	#1,a3
	move.b	(a3),d7
	extb.l	d7
	move.l	d7,d0
	sub.l	#48,d0
	cmp.l	#9,d0
	jhi	.L70
	move.l	(4,pc,d0.l*4),a0
;$$sw
	jmp	(a0)
.L130:
	DC.L	.L69
	DC.L	.L69
	DC.L	.L69
	DC.L	.L69
	DC.L	.L69
	DC.L	.L69
	DC.L	.L69
	DC.L	.L69
	DC.L	.L69
	DC.L	.L69
;$$se
.L69:
	move.l	d2,d0
	add.l	d0,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d7,d1
	add.l	#-48,d1
	move.l	d1,d2
	jra	.L58
.L70:
	subq.l	#1,a3
	moveq	#1,d5
	jra	.L58
.L71:
	subq.l	#1,a3
	moveq	#0,d0
	move.l	d0,-44(a6)
	moveq	#0,d2
.L72:
	moveq	#0,d0
	move.l	d0,-48(a6)
	addq.l	#1,a3
	move.b	(a3),d7
	extb.l	d7
	move.l	d7,d0
	add.l	#-76,d0
	jeq	.L76
	add.l	#-28,d0
	jeq	.L74
	subq.l	#4,d0
	jeq	.L75
	jra	.L77
.L74:
	bset	#0,-48(a6)
	jra	.L73
.L75:
	bset	#1,-48(a6)
	jra	.L73
.L76:
	bset	#2,-48(a6)
	jra	.L73
.L77:
	subq.l	#1,a3
.L73:
	addq.l	#1,a3
	move.b	(a3),d7
	extb.l	d7
	move.l	d7,d0
	sub.l	#88,d0
	cmp.l	#32,d0
	jhi	.L122
	move.l	(4,pc,d0.l*4),a0
;$$sw
	jmp	(a0)
.L131:
	DC.L	.L95
	DC.L	.L122
	DC.L	.L122
	DC.L	.L122
	DC.L	.L122
	DC.L	.L122
	DC.L	.L122
	DC.L	.L122
	DC.L	.L122
	DC.L	.L122
	DC.L	.L105
	DC.L	.L114
	DC.L	.L80
	DC.L	.L122
	DC.L	.L122
	DC.L	.L122
	DC.L	.L122
	DC.L	.L80
	DC.L	.L122
	DC.L	.L122
	DC.L	.L122
	DC.L	.L122
	DC.L	.L121
	DC.L	.L103
	DC.L	.L106
	DC.L	.L122
	DC.L	.L122
	DC.L	.L115
	DC.L	.L122
	DC.L	.L107
	DC.L	.L122
	DC.L	.L122
	DC.L	.L95
;$$se
.L80:
	move.l	16(a6),a0
	addq.l	#4,16(a6)
	move.l	(a0),-52(a6)
	pea	10.w
	pea	1.w
	pea	-52(a6)
	pea	-36(a6)
;$$fn 0x303
	jbsr	_printk_mknumstr
	lea	16(a7),a7
	move.l	d0,d6
	lea	-36(a6,d6),a2
	tst.l	-52(a6)
	jpl	.L85
	moveq	#45,d0
	move.l	d0,-56(a6)
	addq.l	#1,d6
	jra	.L86
.L85:
	btst	#1,d4
	jeq	.L83
	moveq	#43,d0
	move.l	d0,-56(a6)
	addq.l	#1,d6
	jra	.L86
.L83:
	btst	#2,d4
	jeq	.L81
	moveq	#32,d0
	move.l	d0,-56(a6)
	addq.l	#1,d6
	jra	.L86
.L81:
	moveq	#0,d0
	move.l	d0,-56(a6)
.L86:
	moveq	#0,d0
	move.l	d0,-60(a6)
	btst	#3,d4
	jeq	.L90
	tst.l	-56(a6)
	jeq	.L87
	move.l	a5,-(a7)
	pea	-40(a6)
	move.l	-56(a6),-(a7)
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
.L87:
	moveq	#1,d0
	move.l	d0,-60(a6)
	move.l	a5,-(a7)
	pea	-40(a6)
	move.l	d3,-(a7)
	move.l	d6,-(a7)
;$$fn 0x303
	jbsr	_printk_pad_zero
	lea	16(a7),a7
	move.l	d3,d6
	jra	.L91
.L90:
	btst	#0,d4
	jne	.L91
	move.l	a5,-(a7)
	pea	-40(a6)
	move.l	d3,-(a7)
	move.l	d6,-(a7)
;$$fn 0x303
	jbsr	_printk_pad_space
	lea	16(a7),a7
	tst.l	-56(a6)
	jeq	.L88
	move.l	a5,-(a7)
	pea	-40(a6)
	move.l	-56(a6),-(a7)
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
.L88:
	moveq	#1,d0
	move.l	d0,-60(a6)
.L91:
	tst.l	-60(a6)
	jne	.L112
	tst.l	-56(a6)
	jeq	.L112
	move.l	a5,-(a7)
	pea	-40(a6)
	move.l	-56(a6),-(a7)
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
	jra	.L112
.L95:
	move.l	16(a6),a0
	addq.l	#4,16(a6)
	move.l	(a0),-72(a6)
	pea	16.w
	clr.l	-(a7)
	pea	-72(a6)
	pea	-36(a6)
;$$fn 0x303
	jbsr	_printk_mknumstr
	lea	16(a7),a7
	move.l	d0,d6
	lea	-36(a6,d6),a2
	moveq	#0,d0
	move.l	d0,-60(a6)
	btst	#3,d4
	jeq	.L100
	btst	#4,d4
	jeq	.L96
	move.l	a5,-(a7)
	pea	-40(a6)
	pea	48.w
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
	move.l	a5,-(a7)
	pea	-40(a6)
	pea	120.w
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
	moveq	#1,d0
	move.l	d0,-60(a6)
.L96:
	move.l	a5,-(a7)
	pea	-40(a6)
	move.l	d3,-(a7)
	move.l	d6,-(a7)
;$$fn 0x303
	jbsr	_printk_pad_zero
	lea	16(a7),a7
	move.l	d3,d6
	jra	.L101
.L100:
	btst	#0,d4
	jne	.L101
	btst	#4,d4
	jeq	.L97
	addq.l	#2,d6
.L97:
	move.l	a5,-(a7)
	pea	-40(a6)
	move.l	d3,-(a7)
	move.l	d6,-(a7)
;$$fn 0x303
	jbsr	_printk_pad_space
	lea	16(a7),a7
	btst	#4,d4
	jeq	.L101
	move.l	a5,-(a7)
	pea	-40(a6)
	pea	48.w
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
	move.l	a5,-(a7)
	pea	-40(a6)
	pea	120.w
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
	moveq	#1,d0
	move.l	d0,-60(a6)
.L101:
	btst	#4,d4
	jeq	.L112
	tst.l	-60(a6)
	jne	.L112
	move.l	a5,-(a7)
	pea	-40(a6)
	pea	48.w
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
	move.l	a5,-(a7)
	pea	-40(a6)
	pea	120.w
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
	addq.l	#2,d6
	jra	.L112
.L103:
	move.l	16(a6),a0
	addq.l	#4,16(a6)
	move.l	(a0),-72(a6)
	pea	8.w
	clr.l	-(a7)
	pea	-72(a6)
	pea	-36(a6)
;$$fn 0x303
	jbsr	_printk_mknumstr
	lea	16(a7),a7
	move.l	d0,d6
	jra	.L104
.L105:
	move.l	16(a6),a0
	addq.l	#4,16(a6)
	move.l	(a0),-72(a6)
	pea	2.w
	clr.l	-(a7)
	pea	-72(a6)
	pea	-36(a6)
;$$fn 0x303
	jbsr	_printk_mknumstr
	lea	16(a7),a7
	move.l	d0,d6
	jra	.L104
.L106:
	move.l	16(a6),a0
	addq.l	#4,16(a6)
	move.l	(a0),-72(a6)
	pea	16.w
	clr.l	-(a7)
	pea	-72(a6)
	pea	-36(a6)
;$$fn 0x303
	jbsr	_printk_mknumstr
	lea	16(a7),a7
	move.l	d0,d6
	jra	.L104
.L107:
	move.l	16(a6),a0
	addq.l	#4,16(a6)
	move.l	(a0),-72(a6)
	pea	10.w
	clr.l	-(a7)
	pea	-72(a6)
	pea	-36(a6)
;$$fn 0x303
	jbsr	_printk_mknumstr
	lea	16(a7),a7
	move.l	d0,d6
.L104:
	lea	-36(a6,d6),a2
	btst	#3,d4
	jeq	.L109
	move.l	a5,-(a7)
	pea	-40(a6)
	move.l	d3,-(a7)
	move.l	d6,-(a7)
;$$fn 0x303
	jbsr	_printk_pad_zero
	lea	16(a7),a7
	move.l	d3,d6
	jra	.L112
.L109:
	btst	#0,d4
	jne	.L112
	move.l	a5,-(a7)
	pea	-40(a6)
	move.l	d3,-(a7)
	move.l	d6,-(a7)
;$$fn 0x303
	jbsr	_printk_pad_space
	lea	16(a7),a7
.L112:
	tst.b	(a2)
	jeq	.L111
	move.l	a5,-(a7)
	pea	-40(a6)
	move.l	a2,a0
	subq.l	#1,a2
	move.b	(a0),d0
	extb.l	d0
	move.l	d0,-(a7)
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
	jra	.L112
.L111:
	btst	#0,d4
	jeq	.L30
	move.l	a5,-(a7)
	pea	-40(a6)
	move.l	d3,-(a7)
	move.l	d6,-(a7)
;$$fn 0x303
	jbsr	_printk_pad_space
	lea	16(a7),a7
	jra	.L30
.L114:
	move.l	16(a6),a0
	addq.l	#4,16(a6)
	move.l	(a0),d0
	extb.l	d0
	move.l	d0,-68(a6)
	move.l	a5,-(a7)
	pea	-40(a6)
	move.l	-68(a6),-(a7)
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
	jra	.L30
.L115:
	move.l	16(a6),a0
	addq.l	#4,16(a6)
	move.l	(a0),a4
	tst.l	a4
	jeq	.L30
	move.l	a4,-(a7)
;$$fn 0x303
	jbsr	_strlen
	addq.l	#4,a7
	move.l	d0,d6
	btst	#0,d4
	jne	.L118
	move.l	a5,-(a7)
	pea	-40(a6)
	move.l	d3,-(a7)
	move.l	d6,-(a7)
;$$fn 0x303
	jbsr	_printk_pad_space
	lea	16(a7),a7
.L118:
	tst.b	(a4)
	jeq	.L117
	move.l	a5,-(a7)
	pea	-40(a6)
	move.b	(a4)+,d0
	extb.l	d0
	move.l	d0,-(a7)
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
	jra	.L118
.L117:
	btst	#0,d4
	jeq	.L30
	move.l	a5,-(a7)
	pea	-40(a6)
	move.l	d3,-(a7)
	move.l	d6,-(a7)
;$$fn 0x303
	jbsr	_printk_pad_space
	lea	16(a7),a7
	jra	.L30
.L121:
	move.l	16(a6),a0
	addq.l	#4,16(a6)
	move.l	(a0),-64(a6)
	move.l	-64(a6),a0
	move.l	-40(a6),(a0)
	jra	.L30
.L122:
	move.l	a5,-(a7)
	pea	-40(a6)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_printk_putc
	lea	12(a7),a7
.L30:
	addq.l	#1,a3
	jra	.L123
.L29:
	move.l	-40(a6),d0
;$$be
;$$br
	movem.l	-112(a6),d2/d3/d4/d5/d6/d7/a2/a3/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_printk,@function
	SIZE	_printk,.-_printk

; Allocations for _printk
;	a5	info
;	12(a6)	fmt
;	16(a6)	ap
;	a3	p
;	d7	c
;	-36(a6)	vstr
;	a2	vstrp
;	d6	vlen
;	d5	done
;	-40(a6)	count
;	d4	flags_used
;	d3	field_width
;	-44(a6)	precision_used
;	d2	precision_width
;	-48(a6)	length_modifier
;	-52(a6)	ival
;	-56(a6)	schar
;	-60(a6)	dschar
;	-64(a6)	ivalp
;	a4	sval
;	-68(a6)	cval
;	-72(a6)	uval
;$$bf
	ALIGN	4
	XDEF	_printD
_printD:
	link	a6,#-16
;$$br
	move.l	a5,-(a7)
	move.l	d7,-(a7)
;$$er
	moveq	#1,d0
	move.l	d0,-12(a6)
	move.l	#_board_out_char,d0
	move.l	d0,-8(a6)
	lea	12(a6),a5
	move.l	a5,-(a7)
	move.l	8(a6),-(a7)
	pea	-12(a6)
;$$fn 0x303
	jbsr	_printk
	lea	12(a7),a7
	move.l	d0,d7
	move.l	d7,d0
;$$be
;$$br
	movem.l	-24(a6),d7/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_printD,@function
	SIZE	_printD,.-_printD

; Allocations for _printD
;	8(a6)	fmt
;	a5	ap
;	d7	rvalue
;	-12(a6)	info
;$$bf
	ALIGN	4
	XDEF	_sprintD
_sprintD:
	link	a6,#-16
;$$br
	move.l	a5,-(a7)
	move.l	d7,-(a7)
;$$er
	moveq	#0,d7
	tst.l	8(a6)
	jeq	.L135
	moveq	#2,d0
	move.l	d0,-12(a6)
	move.l	8(a6),-4(a6)
	lea	16(a6),a5
	move.l	a5,-(a7)
	move.l	12(a6),-(a7)
	pea	-12(a6)
;$$fn 0x303
	jbsr	_printk
	lea	12(a7),a7
	move.l	d0,d7
	move.l	-4(a6),a0
	clr.b	(a0)
.L135:
	move.l	d7,d0
;$$be
;$$br
	movem.l	-24(a6),d7/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_sprintD,@function
	SIZE	_sprintD,.-_sprintD

; Allocations for _sprintD
;	8(a6)	s
;	12(a6)	fmt
;	a5	ap
;	d7	rvalue
;	-12(a6)	info

; Allocations for module
	
